// Datei Ausfuellen.java
/* ------------------------------------------------------------------------
Dieses Programm erzeugt ein PoxelPanel und zeichnet darauf ein paar
unregelmaessige Figuren, von denen jede durch eine "schwarze Linie"
begrenzt wird. Dann werden einige dieser Figuren mit Hilfe der Methode
fuelle mit einer bestimmten Farbe (und einem bestimmten Zeichen) gefuellt.
------------------------------------------------------------------------ */
import javax.swing.JFrame;
import java.awt.Color;

public class Ausfuellen {
   // ---------------------------------------------------------------------
   static final boolean TST = false;
   // ---------------------------------------------------------------------
   // Die Reihung sr beschreibt die unregelmaessigen Figuren, die auf
   // das PoxelPanel pop gezeichnet werden:
   static String[] sr = {
      ".....XXXXXX...........X........",  //  0
      ".XXXXX....X..........X.X.......",  //  1
      "XX.....:XXXXXXXX.XXXXX.XXXX....",  //  2
      "X..XX...:......XX..........X...",  //  3
      "X.XXX.XXXXXXXXXX.XXXXX.XXX.X...",  //  4
      "X.X.X:X..............X.X.X.X...",  //  5
      "XXX.X.X..............X.XX..X...",  //  6
      "....X.X..............X.X.X.X...",  //  7
      "....X.X..............X.XXX.X...",  //  8
      "....XXX..............X.....X...",  //  9
      ".....................XXXXX.X...",  // 10
      "...XXX.......XXXXXXX....X..X...",  // 11
      "...X.X...,,,,X.....X....:X..X..",  // 12
      "...X.XXXXXX..XXX...X....X..X...",  // 13
      "XXXX......X....X...X...X..X....",  // 14
      "X....XXXXXX....X...X....X..X...",  // 15
      "XXXXXX.........XXXXX.....XX....",  // 16
      "...............................",  // 17
      "...............................",  // 18
   };
   //  0123456789012345678901234567890
   //            1         2         3
   // ---------------------------------------------------------------------
   static void zeichneFiguren(PoxelPanel pop) {
      // Fuer jede char-Variable sr[y].charAt(x) die den Wert 'X' hat
      // wird in pop in das Poxel (x, y) die Farbe BLACK und das
      // Zeichen 'X' geschrieben.
      for (int y=0; y<sr.length; y++) {
         String s = sr[y];
         for (int x=0; x<s.length(); x++) {
            if (s.charAt(x) != 'X') continue;
            pop.drawRect(x, y, Color.BLACK, 'X');
         }
      }
   } // zeichneFiguren
   // ---------------------------------------------------------------------
   static
   void fuelle(PoxelPanel pop, int x, int y, Color color1, char char1) {
      // Schwarze Poxel gelten hier als Begrenzer (einer Flaeche auf pop).
      // Wenn das aktuellen Poxel (x, y) schwarz ist, passiert nichts.
      // Sonst werden das Poxel (x, y) und alle mit ihm verbundenen,
      // nicht-schwarzen Poxel mit der Farbe color1 und dem Zeichen char1
      // gefuellt (d.h. beschrieben).

      // DEN RUMPF DIESER EINEN METHODE SOLLEN SIE ERGAENZEN

   } // fuelle
   // ---------------------------------------------------------------------
   static private JFrame macheJF(String titel, PoxelPanel pop) {
      JFrame jf = new JFrame(titel);
      jf.add(pop, "Center");
      jf.pack();
      jf.setLocation(100, 50);
      jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      jf.setVisible(true);
      return jf;
   } // macheJF
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("Ausfuellen: Jetzt geht es los!%n");

      final int AX = sr[0].length(); // Anz. Poxel in x-Richtung (pro Zeile)
      final int AY = sr.length;      // Anz. Poxel in y-Richtung (pro Spalte)

      // Ein PoxelPanel pop in einem JFrame anzeigen:
      PoxelPanel pop = new PoxelPanel(AX, AY);
      JFrame     ram = macheJF("Test-PoxelPanel:", pop);

      zeichneFiguren(pop);

      // Vier (durch schwarze Linien begrenzte) Figuren mit
      // unterschiedlichen Farben und den Zeichen '1' bis '4' fuellen
      // (der Hintergrund von jedem PoxelPanel ist anfangs YELLOW).
      fuelle(pop,  3,  2, Color.RED  , '1');
      fuelle(pop,  2, 15, Color.GREEN, '2');
      fuelle(pop, 17,  3, Color.BLUE,  '3');
      fuelle(pop, 12,  7, Color.WHITE, '4');

      printf("Ausfuellen: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class Ausfuellen
