// Datei Faden30Tst.java
/* ------------------------------------------------------------------------
Zwei Faeden (engl. threads) namens O und X versuchen mehrmals, die globale
StringBuilder-Variable text ganz mit 'O's bzw. 'X'en zu fuellen und
auszugeben. Die Ausgaben enthalten manchmal Mischungen aus 'O's und 'X'en.
------------------------------------------------------------------------ */
import java.util.Random;

class Faden30 extends Thread {
   static StringBuilder text = new StringBuilder("XXXXXXXXXXXXXXXXXXXX");

   Random rand = new Random();
   String name;

   public Faden30(String name) {
      super(name);
      this.name = name;
   } // Konstruktor Faden30

   public void run() {
      try {
         for (int i=1; i<=5; i++) {
            for (int j=0; j<text.length(); j++) {   // text fuellen
               text.replace(j, j+1, name);
               Thread.sleep(rand.nextInt(10));
            }
            System.out.println(name + ": " + text); // text ausgeben
            Thread.sleep(rand.nextInt(10));
         }
      } catch (InterruptedException ex) {
         System.out.println("Ausnahme in Methode run: " + ex);
      }
   }
} // class Faden30
// ========================================================================
public class Faden30Tst {

   static public void main(String[] _) {
      System.out.println("Faden30Tst:  Los jetzt!");
      System.out.println("Faden: " + Thread.currentThread().getName());
      Faden30 fO = new Faden30("O");
      Faden30 fX = new Faden30("X");
      fO.start();
      fX.start();
      System.out.println("Faden30Tst:  Das war's!");
   } // main

} // class Faden30Tst
/* ========================================================================
Drei moegliche Ausgaben des Programms Faden30Tst (nebeneinander):

Faden30Tst:  Los jetzt!   Faden30Tst:  Los jetzt!   Faden30Tst:  Los jetzt!
Faden30Tst:  Das war's!   Faden30Tst:  Das war's!   Faden30Tst:  Das war's!
X: XOOOOOOOOOOOOOOOOXXX   O: OXXXXXXXOXXXXOXXXXXX   O: XOOOOOOOOXXXOXOOOOXO
O: XXOOOOOOOOOOOOOOOOOO   X: OXXXXXXXOXXXXOXXXXXX   X: OOOOOOOOOXXXOXOOOOXX
X: OOOOOOOOOOXXXOOOOOOX   X: XOOXOOOOOOOOOOOOOXXX   O: XXXXXXXXXXXXXXXOOOOX
O: XXOOOOOOOOXXXOOOOOOO   O: XXOXOOOOOOOOOOOOOOOO   X: OXXXXXXXXXXXXXXOOOOX
X: OOOOOOOOOOOOOOOOOOXX   X: OOOOOOOOOOOOOOOOOOOO   X: XXOOOOOOOOOOOXXXXXXX
O: XXXXOOOOOOOOOOOOOOOO   O: XOOOOOOOOOOOOOOOOOOO   O: XXXXXXOOOOOOOOOOOOOO
O: OOOOOOOOOOOOOOXXXXXX   X: OOXXXXXOOOOOOOOOOOOO   X: OOOOOOOOOOOOOOOXXXXX
X: OOOOOOOOOOOOOOXXXXXX   O: XOXXXXXOOOOOOOOOOOOO   O: XXXXOOOOOOOOOOOOOOOO
O: XXXXXXXXXXXXXXXXXXOO   O: OOOOXXXXXXXXXXXXXXOO   X: OOOOOOOOOOOOOOOXXXXX
X: XXXXXXXXXXXXXXXXXXXX   X: OOOOXXXXXXXXXXXXXXXX   O: OOOOOOOOOOOOOOOOOOOO
======================================================================== */
