// Datei RandomWalk01.java
/* ------------------------------------------------------------------------
Unvollstaendige Version der Datei RandomWalk01.java.
befolgend Sie die Hinweise MUSS ERSETZT WERDEN und
entfernen Sie die drei Zeilen, die Sie gerade gelesen haben (Zeilen 3-5).

Dieses Programm erzeugt ein PoxelPanel und gibt darauf einen Zufallsweg
(engl. random walk) aus. Die Ausgabe der einzelnen Schritte wird so
verzoegert, dass ein Betrachter sie noch als "sequentielle Schritte"
wahrnehmen kann.

Die Groesse des PoxelPanels wird durch die Konstanten anzX und anzY
festgelegt.

Der Zufallsweg beginnt bei einem zufaellig gewaehlten Poxel.
Die Laengen der einzelnen Zufallsschritte sind durch die Konstanen
mDX und mDY (max Poxel in x- bzw. y-Richtung) begrenzt.

Beispiel: Ist mDX gleich 5 und mDY gleich 3, dann sind vom Poxel A aus
alle mit N gekennzeichneten Poxel (und das A-Poxel selbst) in EINEM Schritt
erreichbar:

                      NNNNNNNNNNN
                      NNNNNNNNNNN
                      NNNNNNNNNNN
                      NNNNNANNNNN
                      NNNNNNNNNNN
                      NNNNNNNNNNN
                      NNNNNNNNNNN

Die Anzahl der Schritte des Zufallsweges wird durch die Konstante
steps festgelegt.

Das jeweils naechste Poxel des Zufallsweges kann wahlweise durch eine
der Methoden nextA, nextB oder nextC festgelegt werden (ein Wechsel
der Methode erfordert eine Rekompilation dieses Programms). Die drei
Methoden unterscheiden sich dann, wenn das naechste Poxel p eigentlich
ausserhalb des PoxelPanels liegt. In einem solchen Fall gilt:
- nextA macht auf der gegenuebliegenden Seite des PoxelPanels weiter.
- nextB "spiegelt p am Rand".
- nextC waehlt einen anderen Zufallsschritt.
------------------------------------------------------------------------ */
import javax.swing.JFrame;
import java .awt  .Color;
import java .util .Random;

import static java.awt.Color.*;

class RandomWalk01 {
   // ---------------------------------------------------------------------
   final static boolean TST = false;
   // ---------------------------------------------------------------------
   final JFrame     ram;  // Ein Rahmen fuer alles
   final PoxelPanel pop;  // Ein PoxelPanel (Groesse: anzX mal anzY)

   final int anzX;        // Anzahl Poxel    in x-Richtung
   final int anzY;        // Anzahl Poxel    in y-Richtung

   final int mDX;         // maximales Delta in x-Richtung
   final int mDY;         // maximales Delta in y-Richtung

   final int steps = 1000;// Anzahl der Schritte eines Zufallsweges

   Random rand;           // Ein Zufallszahlen-Generator
   // ---------------------------------------------------------------------
   public RandomWalk01() {
      // Initialisiert das aktuelle RandomWalk01-Objekt mit den
      // Werten eines typischen random walks (waehlen Sie diese
      // Werte nach Ihrem Geschmack)
      // Ruft dazu den anderen Konstruktor (den mit Parametern) auf.

      this("Pickelhering", 0, 0, 0, 0); // MUSS ERSETZT WERDEN

   } // Standard-Konstruktor RandomWalk01
   // ---------------------------------------------------------------------
   public RandomWalk01(String titel, int anzX, int anzY, int mDX, int mDY) {
      this.anzX = anzX;  // Breite von pop (in Poxeln)
      this.anzY = anzY;  // Hoehe  von pop (in Poxeln)
      this.mDX  = mDX;   // maximales Delta in x-Richtung
      this.mDY  = mDY;   // maximales Delta in y-Richtung

      this.pop  = null;  // MUSS ERSETZT WERDEN
      this.ram  = null;  // MUSS ERSETZT WERDEN

      walk();            // Zeichne einen random walk nach pop
   } // Konstruktor RandomWalk01
   // ---------------------------------------------------------------------
   public RandomWalk01(String titel) {
      // Ein "besonderer Konstruktor", der nur vom Testprogramm
      // RandomWalk01Jut benutzt werden sollte. Erzeugt kein
      // PoxelPanel und keinen JFrame und zeichnet keinen Zufallsweg,
      // ermoeglicht es aber, die Methoden nextA, nextB und nextC zu testen.

      this.anzX = 0;     // Breite von pop (in Poxeln)
      this.anzY = 0;     // Hoehe  von pop (in Poxeln)
      this.mDX  = 0;     // maximales Delta in x-Richtung
      this.mDY  = 0;     // maximales Delta in y-Richtung

      this.pop  = null;
      this.ram  = null;
      this.rand = null;
   } // Konstruktor RandomWalk01
   // ---------------------------------------------------------------------
   JFrame machNenJFrame(String titel, PoxelPanel pop) {
      JFrame jf = new JFrame(titel);
      jf.setContentPane(pop);
      jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      jf.pack();
      jf.setLocation(100, 50);
      jf.setVisible(true);
      return jf;
   } // machNenJFrame
   // ---------------------------------------------------------------------
   int nextA(int vAlt, int mDV, int anzV, Random rand) {
      // vAlt: Alter Wert einer zufaellig zu veraendernden Variable
      // mDV : Betrag der maximal erlaubten Veraenderung
      // anzV: Anzahl der moeglichen Werte von v
      //       (oder: v darf Werte zwischen 0 und anzV-1 annehmen).
      // rand: Ein Random-Objekt
      //
      // Diese Methode berechnet und liefert
      // einen zufaellig gewaehlten naechsten Wert fuer vAlt.
      // Strategie:
      // Nach "ganz rechts" kommt "ganz links" und umgekehrt.
      // Nach "ganz unten"  kommt "ganz oben"  und umgekehrt

      return 0; // MUSS ERSETZT WERDEN
   } // nextA
   // ---------------------------------------------------------------------
   int nextB(int vAlt, int mDV, int anzV, Random rand) {
      // vAlt: Alter Wert einer zufaellig zu veraendernden Variable
      // mDV : Betrag der maximal erlaubten Veraenderung
      // anzV: Anzahl der moeglichen Werte von v
      //       (oder: v darf Werte zwischen 0 und anzV-1 annehmen).
      // rand: Ein Random-Objekt
      //
      // Diese Methode berechnet und liefert
      // einen zufaellig gewaehlten naechsten Wert fuer vAlt.
      // Strategie:
      // Geht ein Schritt ueber den Rand hinaus, wird er "am Rand gespiegelt".
      // Beispiele-1: Wenn v gleich +2 ist:
      //   statt um -3 nach     -1 wird nach     +1 gesprungen
      //   statt um -4 nach     -2 wird nach     +2 gesprungen
      //   statt um -5 nach     -3 wird nach     +3 gesprungen etc.
      // Beispiele-2: Wenn v gleich anzV-2 ist:
      //   statt um +2 nach anzV+0 wird nach anzV-1 gesprungen
      //   statt um +3 nach anzV+1 wird nach anzV-2 gesprungen
      //   statt um +4 nach anzV+2 wird nach anzV-3 gesprungen etc.

      return 0; // MUSS ERSETZT WERDEN
   } // nextB
   // ---------------------------------------------------------------------
   int nextC(int vAlt, int mDV, int anzV, Random rand) {
      // vAlt: Alter Wert einer zufaellig zu veraendernden Variable
      // mDV : Betrag der maximal erlaubten Veraenderung
      // anzV: Anzahl der moeglichen Werte von v
      //       (oder: v darf Werte zwischen 0 und anzV-1 annehmen).
      // rand: Ein Random-Objekt
      //
      // Diese Methode berechnet und liefert
      // einen zufaellig gewaehlten naechsten Wert fuer vAlt.
      // Strategie:
      // Geht ein Schritt ueber den Rand hinaus, wird er
      // verworfen und ein anderer Schritt gewaehlt. Das wird
      // wiederholt, bis ein akzeptabler Schritt gefunden wurde.

      return 0; // MUSS ERSETZT WERDEN
   } // nextC
   // ---------------------------------------------------------------------
   void schlafRuhig(long ms) {
      // Verzoegert den ausfuehrenden Faden, mindestens um ms Millisekunden.
      // Faengt Ausnahmen des (geprueften) Typs InterruptedException ab.

      try {
         Thread.sleep(ms);
      } catch (InterruptedException ex) {
         printf("Ausnahme in Methode walk:%n");
         printf("%s%n", ex);
      }
   } // schlafRuhig
   // ---------------------------------------------------------------------
   void walk() {
      // Gibt einen Zufallsweg zum PoxelPanel pop aus. Dieser Zufallsweg
      // beginnt bei einem Poxel, dessen Koordinaten zufaellig gewaehlt
      // werden. Die Koordinaten des jeweils naechsten Poxels werden mit
      // der Methode nextA (bzw. nextB, nextC) ermittelt. Insgesamt werden
      // steps viele Poxel ausgegeben.

      int x = 0; // MUSS ERSETZT WERDEN

   } // walk
   // ---------------------------------------------------------------------
   static Color[] cTab = {
      // Eine Tabelle mit ein paar Color-Objekten. Die Namen BLACK,
      // BLUE, ..., WHITE bezeichnen Klassenattribute der Klasse Color.

      BLACK,
      BLUE   .darker(),   BLUE,      BLUE   .brighter(),
      CYAN   .darker(),   CYAN,      CYAN   .brighter(),
      GRAY   .darker(),   GRAY,      GRAY   .brighter(),
      GREEN  .darker(),   GREEN,     GREEN  .brighter(),
      MAGENTA.darker(),   MAGENTA,   MAGENTA.brighter(),
      ORANGE .darker(),   ORANGE,    ORANGE .brighter(),
      PINK   .darker(),   PINK,      PINK   .brighter(),
      RED    .darker(),   RED,       RED    .brighter(),
      YELLOW .darker(),   YELLOW,    YELLOW .brighter(),
      WHITE,
   };
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("RandomWalk01: Jetzt geht es los!%n");

//    RandomWalk01 rw00 = new RandomWalk01();
      RandomWalk01 rw01 = new RandomWalk01("Random Walk 1", 60, 40, 3, 3);

      printf("RandomWalk01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Methoden mit kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class RandomWalk01
