// File RechnerView_I.java
/* ------------------------------------------------------------------------
View components of the Rechner should implement this interface.
See file RechnerControl.java for more information about the Rechner.

Authors: Agathe Merceron, Ulrich Grude
------------------------------------------------------------------------ */
package rechner;

import java.awt.event.ActionListener;
import java.awt.event.KeyListener;

public interface RechnerView_I {
   // Each implementing class is expected to declare at least
   // - 1 submit button      (e.g. of type JButton)
   // - 2 input  text fields (e.g. of type JTextField)
   // - 5 result text fields (e.g. of type JTextField)

   void register(ActionListener al, KeyListener kl1, KeyListener kl2);
   // Registers (using the appropriate addXXXListener method)
   // al  with the submit button,
   // kl1 with with the first  input text field and
   // kl2 with with the second input text field.

   String getNumber1();
   // Returns the content of the first input text field.

   String getNumber2();
   // Returns the content of the second input text field,

   void setResults(String[] results);
   // Expects the array results to be of lenght 5.
   // Assigns each of its elements to one of the result text fields.

} // inteface RechnerView_I
