// Datei UebReku.java
/* ------------------------------------------------------------------------
Dieses Programm UebReku enthaelt eine Reihe von rekursiven (Klassen-)
Methoden und ruft diese ein paar mal auf.
------------------------------------------------------------------------ */
class UebReku {
   // ---------------------------------------------------------------------
   static public int potenzR(final int BASIS, final int EXPONENT) {
      // Wirft eine Ausnahme, falls der EXPONENT negativ ist.
      // Liefert sonst die Zahl BASIS hoch EXPONENT.
      if (EXPONENT<0) throw new Error (
         "potenzR: Negativer EXPONENT " + EXPONENT + " ist nicht erlaubt!"
      );

      return -1; // MUSS ERSETZT WERDEN!

      // Alternativer Befehl (fuer die Freunde einzeiliger Loesungen):
      // return (EXPONENT==0) ? 1 : BASIS * potenzR(BASIS, EXPONENT-1);
   } // potenzR
   // ---------------------------------------------------------------------
   static public int multR(final int N1, final int N2) {
      // Liefert das Produkt von N1 und N2.
      if (N1 <  0) return -multR(-N1, N2); // Pseudo-Rekursion

      return -1; // MUSS ERSETZT WERDEN!
   } // multR
   // ---------------------------------------------------------------------
   static public int anz10erZiffernR(final int N) {
      // Wieviele Ziffern braucht man, um N als Zahl im System mit der
      // Basis 10 darzustellen? Diese Funktion liefert die Antwort.

      return -1; // MUSS ERSETZT WERDEN!
   } // anz10erZiffernR
   // ---------------------------------------------------------------------
   static public int anzBerZiffernR(final int N, final int B) {
      // Wieviele Ziffern braucht man, um N als Zahl im System mit der
      // Basis |B| (Betrag von B) darzustellen? Diese Funktion liefert
      // die Antwort.

      return -1; // MUSS ERSETZT WERDEN!
   } // anzBerZiffernR
   // ---------------------------------------------------------------------
   static public int quersumme10erR(final int N) {
      // Welche Quersumme hat die Zahl N, wenn man sie im System mit der
      // Basis 10 ("als Dezimalzahl") darstellt? Diese Funktion liefert
      // die Antwort.

      return -1; // MUSS ERSETZT WERDEN!
   } // quersumme10erR
   // ---------------------------------------------------------------------
   static public int quersummeBerR(final int N, final int B) {
      // Welche Quersumme hat die Zahl N, wenn man sie im System mit der
      // Basis |B| ("als B-er-Zahl") darstellt? Diese Funktion liefert
      // die Antwort.

      return -1; // MUSS ERSETZT WERDEN!
   } // quersummeBerR
   // ---------------------------------------------------------------------
   static public String drehRumR(final String S) {
      // Liefert einen String, der die gleichen Zeichen enthaelt wie S,
      // aber in umgekehrter Reihenfolge. Beispiel:
      // drehRumR("ABC") ist gleich "CBA".
      // if (S.length() <= 1) return S;                 // Einfacher Fall
      // return drehRumR(S.substring(1)) + S.charAt(0); // Rekursion

     return "Fehler!"; // MUSS ERSETZT WERDEN!
   } // drehRumR
   // ---------------------------------------------------------------------
   static public boolean istPalindromR(final String S) {
      // Liefert true genau dann wenn S ein Palindrom ist.
      // Beispiele fuer Palindrome: "ANNA", "OTTO", ABCBA".

      return false; // MUSS ERSETZT WERDEN!
   } // istPalindromR
   // ---------------------------------------------------------------------
   static public int anzSchoeneZeichenR(final String S) {
      // Liefert die Anzahl der schoenen Zeichen in S. Welche Zeichen
      // schoen sind, wird durch die Funktion istSchoen festgelegt.

      return -1; // MUSS ERSETZT WERDEN!
   } // anzSchoeneZeichenR

   static public boolean istSchoen(char c) {
      // Liefert true, genau dann wenn c eine 10-er-Ziffer ist.
      return '0' <= c && c <= '9';
   } // istSchoen
   // ---------------------------------------------------------------------
   // Die Funktion anzGeradeZahlen  hat 1 Parameter und ist nicht-rekursiv.
   // Die Funktion anzGeradeZahlenR hat 2 Parameter und ist       rekursiv.

   static public int anzGeradeZahlen(int[] ir) {
      // Liefert die Anzahl der geraden Zahlen in ir.
      return anzGeradeZahlenR(ir, 0);
   } // anzGeradeZahlen

   static public int anzGeradeZahlenR(int[] ir, int ind) {
      return -1; // MUSS ERSETZT WERDEN!
   } // anzGeradeZahlenR

   static public boolean istGerade(int n) {
      return n % 2 == 0;
   } // istGerade
   // ---------------------------------------------------------------------
   static int anzFiboR = 0; // Wie oft wird fiboR aufgerufen?

   static public long fiboR(final int N) {  // Fibonacci-Zahlen, rekursiv
      // Diese Funktion liefert die N-te Fibonacci-Zahl (und zaehlt in der
      // Variablen anzFiboR wie oft sie aufgerufen wurde)
      // N sollte groesser oder gleich 0 sein. Alle negativen Zahlen
      // werden (der Einfachheit halber) wie die Zahl 0 behandelt.

      anzFiboR++;

      return -1; // MUSS ERSETZT WERDEN!
   } // fiboEinfachR
   // ---------------------------------------------------------------------
   static public long fiboQ(final int N) {  // Fibonacci-Zahlen, quick
      // Liefert die N-te Fibonacci-Zahl. Erzeugt dazu eine long-Reihung
      // fibo der Laenge N+1 und schreibt die i-te-Fibonacci-Zahl in die
      // Komponente fibo[i].
      return -1; // MUSS ERSETZT WERDEN!
   } // fiboQ
   // ---------------------------------------------------------------------
   static public long fiboD(final int N) {  // Fibonacci-Zahlen, direkt
      final double W5 = Math.sqrt(5.0);

      final double A = Math.pow(1.0 + W5, N);
      final double B = Math.pow(1.0 - W5, N);
      final double C = Math.pow(   2    , N) * W5;

      return (long) ((A - B) / C);
   } // fiboD
   // ---------------------------------------------------------------------
   static public void potenzRTst() {
      printf("potenzR(+2,  0): % d%n", potenzR(+2,  0));
      printf("potenzR(+2,  1): % d%n", potenzR(+2,  1));
      printf("potenzR(+2,  2): % d%n", potenzR(+2,  2));
      printf("potenzR(+2,  3): % d%n", potenzR(+2,  3));
      printf("potenzR(+2, 10): % d%n", potenzR(+2, 10));
      printf("potenzR(+2, 11): % d%n", potenzR(+2, 11));
      printf("---------------------------%n");
      printf("potenzR(-2,  0): % d%n", potenzR(-2,  0));
      printf("potenzR(-2,  1): % d%n", potenzR(-2,  1));
      printf("potenzR(-2,  2): % d%n", potenzR(-2,  2));
      printf("potenzR(-2,  3): % d%n", potenzR(-2,  3));
      printf("potenzR(-2, 10): % d%n", potenzR(-2, 10));
      printf("potenzR(-2, 11): % d%n", potenzR(-2, 11));

      try {
         printf("potenzR(+2, -17): % d%n", potenzR(+2, -17));
      } catch (Error err) {
         printf("Error: %s%n", err.getMessage());
      }

   } // potenzRTst
   // ---------------------------------------------------------------------
   static public void multRTst() {
      printf("multR(+3, +2): % d%n", multR(+3, +2));
      printf("multR(+3, -2): % d%n", multR(+3, -2));
      printf("multR(-3, +2): % d%n", multR(-3, +2));
      printf("multR(-3, -2): % d%n", multR(-3, -2));
      printf("-----------------%n");
      printf("multR(-1, +2): % d%n", multR(-1, +2));
      printf("multR( 0, +2): % d%n", multR( 0, +2));
      printf("multR(+1, +2): % d%n", multR(+1, +2));
      printf("-----------------%n");
      printf("multR(-1, -2): % d%n", multR(-1, -2));
      printf("multR( 0, -2): % d%n", multR( 0, -2));
      printf("multR(+1, -2): % d%n", multR(+1, -2));
   } // multRTst
   // ---------------------------------------------------------------------
   static public void anz10erZiffernRTst() {
      printf("anz10erZiffernR(     0): %2d%n", anz10erZiffernR(     0));
      printf("anz10erZiffernR(    +1): %2d%n", anz10erZiffernR(    +1));
      printf("anz10erZiffernR(    -1): %2d%n", anz10erZiffernR(    -1));
      printf("anz10erZiffernR(    +9): %2d%n", anz10erZiffernR(    +9));
      printf("anz10erZiffernR(    -9): %2d%n", anz10erZiffernR(    -9));
      printf("anz10erZiffernR( +1234): %2d%n", anz10erZiffernR( +1234));
      printf("anz10erZiffernR( -4321): %2d%n", anz10erZiffernR( -4321));
      printf("anz10erZiffernR(100000): %2d%n", anz10erZiffernR(100000));
   } // anz10erZiffernRTst
   // ---------------------------------------------------------------------
   static public void anzBerZiffernRTst() {
      printf("anzBerZiffernR(    0,   2): %2d%n", anzBerZiffernR(    0,   2));
      printf("anzBerZiffernR( +255,  +2): %2d%n", anzBerZiffernR( +255,  +2));
      printf("anzBerZiffernR( -255,  -2): %2d%n", anzBerZiffernR( -255,  -2));
      printf("anzBerZiffernR(  255,  16): %2d%n", anzBerZiffernR(  255,  16));
      printf("anzBerZiffernR( 1234,  10): %2d%n", anzBerZiffernR( 1234,  10));
      printf("anzBerZiffernR(  789, 789): %2d%n", anzBerZiffernR(  789, 789));
   } // anzBerZiffernRTst
   // ---------------------------------------------------------------------
   static public void quersumme10erRTst() {
      printf("quersumme10erR(     0): %2d%n", quersumme10erR(     0));
      printf("quersumme10erR(    +1): %2d%n", quersumme10erR(    +1));
      printf("quersumme10erR(    -1): %2d%n", quersumme10erR(    -1));
      printf("quersumme10erR(    +9): %2d%n", quersumme10erR(    +9));
      printf("quersumme10erR(    -9): %2d%n", quersumme10erR(    -9));
      printf("quersumme10erR( +1234): %2d%n", quersumme10erR( +1234));
      printf("quersumme10erR( -4321): %2d%n", quersumme10erR( -4321));
      printf("quersumme10erR(999999): %2d%n", quersumme10erR(999999));
   } // quersumme10erRTst
   // ---------------------------------------------------------------------
   static public void quersummeBerRTst() {
      printf("quersummeBerR(     0, +2): %2d%n", quersummeBerR(     0, +2));
      printf("quersummeBerR(    +1, -2): %2d%n", quersummeBerR(    +1, -2));
      printf("quersummeBerR(    -1, +2): %2d%n", quersummeBerR(    -1, +2));
      printf("quersummeBerR(    +9, -3): %2d%n", quersummeBerR(    +9, -3));
      printf("quersummeBerR(    -9, +3): %2d%n", quersummeBerR(    -9, +3));
      printf("quersummeBerR( +4095, +2): %2d%n", quersummeBerR( +4095, +2));
      printf("quersummeBerR( -4096, -2): %2d%n", quersummeBerR( -4096, -2));
      printf("quersummeBerR(  4095, 16): %2d%n", quersummeBerR(  4095, 16));
   } // quersummeBerRTst
   // ---------------------------------------------------------------------
   static public void drehRumRTst() {
      printf("drehRumR(\"\")     : ->%s<-%n", drehRumR("")     );
      printf("drehRumR(\"A\")    : ->%s<-%n", drehRumR("A")    );
      printf("drehRumR(\"AB\")   : ->%s<-%n", drehRumR("AB")   );
      printf("drehRumR(\"ABC\")  : ->%s<-%n", drehRumR("ABC")  );
      printf("drehRumR(\"ABCD\") : ->%s<-%n", drehRumR("ABCD") );
      printf("drehRumR(\"ABCDE\"): ->%s<-%n", drehRumR("ABCDE"));
   } // drehRumRTst
   // ---------------------------------------------------------------------
   static public void istPalindromRTst() {
      printf("istPalindromR(\"\")     : %s%n", istPalindromR("")     );
      printf("istPalindromR(\"A\")    : %s%n", istPalindromR("A")    );
      printf("istPalindromR(\"AB\")   : %s%n", istPalindromR("AB")   );
      printf("istPalindromR(\"AA\")   : %s%n", istPalindromR("AA")   );
      printf("istPalindromR(\"ABC\")  : %s%n", istPalindromR("ABC")  );
      printf("istPalindromR(\"ABA\")  : %s%n", istPalindromR("ABA")  );
      printf("istPalindromR(\"ABCD\") : %s%n", istPalindromR("ABCD") );
      printf("istPalindromR(\"ABBA\") : %s%n", istPalindromR("ABBA") );
      printf("istPalindromR(\"ABCDE\"): %s%n", istPalindromR("ABCDE"));
      printf("istPalindromR(\"ABCBA\"): %s%n", istPalindromR("ABCBA"));
   } // istPalindromRTst
   // ---------------------------------------------------------------------
   static public void anzSchoeneZeichenRTst() {
      printf("anzSchoeneZeichenR(\"\")     : %s%n", anzSchoeneZeichenR("")     );
      printf("anzSchoeneZeichenR(\"A\")    : %s%n", anzSchoeneZeichenR("A")    );
      printf("anzSchoeneZeichenR(\"A1\")   : %s%n", anzSchoeneZeichenR("A1")   );
      printf("anzSchoeneZeichenR(\"12\")   : %s%n", anzSchoeneZeichenR("12")   );
      printf("anzSchoeneZeichenR(\"ABC\")  : %s%n", anzSchoeneZeichenR("ABC")  );
      printf("anzSchoeneZeichenR(\"9B8\")  : %s%n", anzSchoeneZeichenR("9B8")  );
      printf("anzSchoeneZeichenR(\"ABCD\") : %s%n", anzSchoeneZeichenR("ABCD") );
      printf("anzSchoeneZeichenR(\"3456\") : %s%n", anzSchoeneZeichenR("3456") );
      printf("anzSchoeneZeichenR(\"ABCDE\"): %s%n", anzSchoeneZeichenR("ABCDE"));
      printf("anzSchoeneZeichenR(\"A1C1A\"): %s%n", anzSchoeneZeichenR("A1C1A"));
   } // anzSchoeneZeichenRTst
   // ---------------------------------------------------------------------
   static public void anzGeradeZahlenTst() {
      int[] ir01 = {};
      int[] ir02 = {1};
      int[] ir03 = {2};
      int[] ir04 = {1, 2, 3, 4, 5};
      int[] ir05 = {1, 3, 5, 7, 9};
      int[] ir06 = {2, 4, 2, 4, 2};

      printf("Test der Funktion anzGeradeZahlen:%n");
      printf("Soll: 0, Ist: %d%n", anzGeradeZahlen(ir01));
      printf("Soll: 0, Ist: %d%n", anzGeradeZahlen(ir02));
      printf("Soll: 1, Ist: %d%n", anzGeradeZahlen(ir03));
      printf("Soll: 2, Ist: %d%n", anzGeradeZahlen(ir04));
      printf("Soll: 0, Ist: %d%n", anzGeradeZahlen(ir05));
      printf("Soll: 5, Ist: %d%n", anzGeradeZahlen(ir06));

   } // anzGeradeZahlenTst
   // ---------------------------------------------------------------------
   static public void fiboRTst() {
      printf("                                      (Anz. Aufrufe)%n");
      printf("fiboR( 0): %,26d (%,12d)%n", fiboR( 0), anzFiboR); anzFiboR=0;
      printf("fiboR( 1): %,26d (%,12d)%n", fiboR( 1), anzFiboR); anzFiboR=0;
      printf("fiboR( 2): %,26d (%,12d)%n", fiboR( 2), anzFiboR); anzFiboR=0;
      printf("fiboR( 3): %,26d (%,12d)%n", fiboR( 3), anzFiboR); anzFiboR=0;
      printf("fiboR( 4): %,26d (%,12d)%n", fiboR( 4), anzFiboR); anzFiboR=0;
      printf("fiboR(10): %,26d (%,12d)%n", fiboR(10), anzFiboR); anzFiboR=0;
      printf("fiboR(20): %,26d (%,12d)%n", fiboR(20), anzFiboR); anzFiboR=0;
      printf("fiboR(30): %,26d (%,12d)%n", fiboR(30), anzFiboR); anzFiboR=0;
      printf("fiboR(40): %,26d (%,12d)%n", fiboR(40), anzFiboR); anzFiboR=0;
   } // fiboRTst
   // ---------------------------------------------------------------------
   static public void fiboQTst() {
      printf("fiboQ( 0): %,26d%n", fiboQ( 0));
      printf("fiboQ( 1): %,26d%n", fiboQ( 1));
      printf("fiboQ( 2): %,26d%n", fiboQ( 2));
      printf("fiboQ( 3): %,26d%n", fiboQ( 3));
      printf("fiboQ( 4): %,26d%n", fiboQ( 4));
      printf("fiboQ(10): %,26d%n", fiboQ(10));
      printf("fiboQ(20): %,26d%n", fiboQ(20));
      printf("fiboQ(30): %,26d%n", fiboQ(30));
      printf("fiboQ(40): %,26d%n", fiboQ(40));
      printf("fiboQ(50): %,26d%n", fiboQ(50));
      printf("fiboQ(60): %,26d%n", fiboQ(60));
      printf("fiboQ(70): %,26d%n", fiboQ(70));
      printf("fiboQ(80): %,26d%n", fiboQ(80));
      printf("fiboQ(90): %,26d%n", fiboQ(90));
      printf("fiboQ(91): %,26d%n", fiboQ(91));
      printf("fiboQ(92): %,26d%n", fiboQ(92));
      printf("fiboQ(93): %,26d%n", fiboQ(93));
   } // fiboQTst
   // ---------------------------------------------------------------------
   static public void fiboDTst() {
      printf("fiboD( 0): %,26d%n", fiboD( 0));
      printf("fiboD( 1): %,26d%n", fiboD( 1));
      printf("fiboD( 2): %,26d%n", fiboD( 2));
      printf("fiboD( 3): %,26d%n", fiboD( 3));
      printf("fiboD( 4): %,26d%n", fiboD( 4));
      printf("fiboD( 5): %,26d%n", fiboD( 5));
      printf("fiboD(11): %,26d%n", fiboD(11));
      printf("fiboD(21): %,26d%n", fiboD(21));
      printf("fiboD(31): %,26d%n", fiboD(31));
      printf("fiboD(41): %,26d%n", fiboD(41));
      printf("fiboD(51): %,26d%n", fiboD(51));
      printf("fiboD(61): %,26d%n", fiboD(61));
      printf("fiboD(71): %,26d%n", fiboD(71));
      printf("fiboD(81): %,26d%n", fiboD(81));
      printf("fiboD(91): %,26d%n", fiboD(91));
      printf("fiboD(92): %,26d%n", fiboD(92));
      printf("fiboD(93): %,26d%n", fiboD(93));
      printf("fiboD(94): %,26d%n", fiboD(94));
   } // fiboDTst
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("UebReku: Jetzt geht es los!%n");

      printf("-------------------------------------%n");
      potenzRTst();
      printf("-------------------------------------%n");
      multRTst();
      printf("-------------------------------------%n");
      anz10erZiffernRTst();
      printf("-------------------------------------%n");
      anzBerZiffernRTst();
      printf("-------------------------------------%n");
      quersumme10erRTst();
      printf("-------------------------------------%n");
      quersummeBerRTst();
      printf("-------------------------------------%n");
      drehRumRTst();
      printf("-------------------------------------%n");
      istPalindromRTst();
      printf("-------------------------------------%n");
      anzSchoeneZeichenRTst();
      printf("-------------------------------------%n");
      anzGeradeZahlenTst();

      printf("-------------------------------------%n");
      fiboRTst();
      printf("-------------------------------------%n");
      fiboQTst();
      printf("-------------------------------------%n");
      fiboDTst();
      printf("-------------------------------------%n");
      printf("UebReku: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class UebReku
/* ------------------------------------------------------------------------
Ausgabe des Programms:

UebReku: Jetzt geht es los!
-------------------------------------
potenzR(+2,  0):  1
potenzR(+2,  1):  2
potenzR(+2,  2):  4
potenzR(+2,  3):  8
potenzR(+2, 10):  1024
potenzR(+2, 11):  2048
---------------------------
potenzR(-2,  0):  1
potenzR(-2,  1): -2
potenzR(-2,  2):  4
potenzR(-2,  3): -8
potenzR(-2, 10):  1024
potenzR(-2, 11): -2048
Error: potenzR: Negativer EXPONENT -17 ist nicht erlaubt!
-------------------------------------
multR(+3, +2):  6
multR(+3, -2): -6
multR(-3, +2): -6
multR(-3, -2):  6
-----------------
multR(-1, +2): -2
multR( 0, +2):  0
multR(+1, +2):  2
-----------------
multR(-1, -2):  2
multR( 0, -2):  0
multR(+1, -2): -2
-------------------------------------
anz10erZiffernR(     0):  1
anz10erZiffernR(    +1):  1
anz10erZiffernR(    -1):  1
anz10erZiffernR(    +9):  1
anz10erZiffernR(    -9):  1
anz10erZiffernR( +1234):  4
anz10erZiffernR( -4321):  4
anz10erZiffernR(100000):  6
-------------------------------------
anzBerZiffernR(    0,   2):  1
anzBerZiffernR( +255,  +2):  8
anzBerZiffernR( -255,  -2):  8
anzBerZiffernR(  255,  16):  2
anzBerZiffernR( 1234,  10):  4
anzBerZiffernR(  789, 789):  2
-------------------------------------
quersumme10erR(     0):  0
quersumme10erR(    +1):  1
quersumme10erR(    -1):  1
quersumme10erR(    +9):  9
quersumme10erR(    -9):  9
quersumme10erR( +1234): 10
quersumme10erR( -4321): 10
quersumme10erR(999999): 54
-------------------------------------
quersummeBerR(     0, +2):  0
quersummeBerR(    +1, -2):  1
quersummeBerR(    -1, +2):  1
quersummeBerR(    +9, -3):  1
quersummeBerR(    -9, +3):  1
quersummeBerR( +4095, +2): 12
quersummeBerR( -4096, -2):  1
quersummeBerR(  4095, 16): 45
-------------------------------------
drehRumR("")     : -><-
drehRumR("A")    : ->A<-
drehRumR("AB")   : ->BA<-
drehRumR("ABC")  : ->CBA<-
drehRumR("ABCD") : ->DCBA<-
drehRumR("ABCDE"): ->EDCBA<-
-------------------------------------
istPalindromR("")     : true
istPalindromR("A")    : true
istPalindromR("AB")   : false
istPalindromR("AA")   : true
istPalindromR("ABC")  : false
istPalindromR("ABA")  : true
istPalindromR("ABCD") : false
istPalindromR("ABBA") : true
istPalindromR("ABCDE"): false
istPalindromR("ABCBA"): true
-------------------------------------
anzSchoeneZeichenR("")     : 0
anzSchoeneZeichenR("A")    : 0
anzSchoeneZeichenR("A1")   : 1
anzSchoeneZeichenR("12")   : 2
anzSchoeneZeichenR("ABC")  : 0
anzSchoeneZeichenR("9B8")  : 2
anzSchoeneZeichenR("ABCD") : 0
anzSchoeneZeichenR("3456") : 4
anzSchoeneZeichenR("ABCDE"): 0
anzSchoeneZeichenR("A1C1A"): 2
-------------------------------------
Test der Funktion anzGeradeZahlen:
Soll: 0, Ist: 0
Soll: 0, Ist: 0
Soll: 1, Ist: 1
Soll: 2, Ist: 2
Soll: 0, Ist: 0
Soll: 5, Ist: 5
-------------------------------------
                                      (Anz. Aufrufe)
fiboR( 0):                          1 (           1)
fiboR( 1):                          1 (           1)
fiboR( 2):                          2 (           3)
fiboR( 3):                          3 (           5)
fiboR( 4):                          5 (           9)
fiboR(10):                         89 (         177)
fiboR(20):                     10.946 (      21.891)
fiboR(30):                  1.346.269 (   2.692.537)
fiboR(40):                165.580.141 ( 331.160.281)
-------------------------------------
fiboQ( 0):                          1
fiboQ( 1):                          1
fiboQ( 2):                          2
fiboQ( 3):                          3
fiboQ( 4):                          5
fiboQ(10):                         89
fiboQ(20):                     10.946
fiboQ(30):                  1.346.269
fiboQ(40):                165.580.141
fiboQ(50):             20.365.011.074
fiboQ(60):          2.504.730.781.961
fiboQ(70):        308.061.521.170.129
fiboQ(80):     37.889.062.373.143.906
fiboQ(90):  4.660.046.610.375.530.309
fiboQ(91):  7.540.113.804.746.346.429
fiboQ(92): -6.246.583.658.587.674.878
fiboQ(93):  1.293.530.146.158.671.551
-------------------------------------
fiboD( 0):                          0
fiboD( 1):                          1
fiboD( 2):                          1
fiboD( 3):                          2
fiboD( 4):                          3
fiboD( 5):                          5
fiboD(11):                         89
fiboD(21):                     10.946
fiboD(31):                  1.346.269
fiboD(41):                165.580.141
fiboD(51):             20.365.011.074
fiboD(61):          2.504.730.781.961
fiboD(71):        308.061.521.170.129
fiboD(81):     37.889.062.373.144.008
fiboD(91):  4.660.046.610.375.544.832
fiboD(92):  7.540.113.804.746.369.024
fiboD(93):  9.223.372.036.854.775.807
fiboD(94):  9.223.372.036.854.775.807
-------------------------------------
UebReku: Das war's erstmal!
------------------------------------------------------------------------ */
