// Datei MeineSammlung.java
/* ------------------------------------------------------------------------
Die Klasse MeineSammlung<K> implementiert die Schnittstelle Collection<K>,
ist also eine (generische) Java-Sammlungsklasse.

Objekte dieser Klasse (z.B. Objekte des Typs MeineKlasse<String> oder
des Typs MeineKlasse<Integer> etc.) sind *unveraenderbar*,
d.h. alle in der Schnittstelle Collection als optional gekennzeichneten
Methoden "funktionieren nicht", sondern werfen nur eine Ausnahme des
Typs NoSuchMethodException.

Die Klasse MeineSammlung enthaelt 3 Konstruktoren: Einen mit einem
Reihungsparameter, einen mit einem Collection-Parameter und einen
ohne Parameter.
---------------------------------------------------------------------------
Formal ist die Vereinbarung der Klasse MeineSammlung<K> in dieser Datei
vollstaendig. D.h. man kann diese Datei kompilieren und der Compiler sollte
dabei keine Fehlermeldungen oder Warnungen ausgeben. Nachdem man diese Datei
compiliert hat, kann man auch das Testprogramm MeineSammlungJut compilieren
und ausfuehren lassen.

Inhaltlich (im Gegensatz zu formal) ist die Klassenvereinbarung in dieser
Datei in hohem Masse *unvollstaendig*. Sie enthaelt 3 Konstruktoren und die
folgenden 9 Methoden, die vollstaendig und fertig implementiert sind:

 1 add          optionale Methode der Schnittstelle Collection
 2 remove            "                     "
 3 addAll            "                     "
 4 removeAll         "                     "
 5 retainAll         "                     "
 6 clear             "                     "
 7 remove       (in der inneren Klasse MeinIterator),
                eine optionale Methode der Schnittstelle Iterator
 8 hashCode     Methode der Schnittstelle Collection
 9 wirfUOE      private Hilfsmethode (nicht aus Collection oder Iterator)

Die folgenden 11 Methoden der Schnittstellen Collection und Iterator sind
dagegen nur "vorlaeufig und unvollstaendig" implementiert:

 1 size
 2 isEmpty
 3 toString
 4 contains
 5 hasNext      (in der inneren Klasse MeinIterator)
 6 next         (in der inneren Klasse MeinIterator)
 7 iterator
 8 containsAll
 9 equals
10 toArray      (ohne Parameter)
11 toArray      (mit  Parameter)

Sie sollen diese 11 Methoden mit Hilfe des Testprogramms MeineSammlungJut
"testgetrieben entwickeln" und so die Klasse MeineSammlung vervollstaendigen.

Gehen Sie dazu wie folgt vor:

1. Compilieren Sie die beiden Quelldateien MeineSammlung.java und Meine-
   SammlungJut.java.

2. Lassen Sie das Testprogramm MeineSammlungJut ausfuehren. Es sollte einen
   gruenen Balken zeigen. Das liegt aber daran, dass es erstmal nur die
   fertig vorgegebenen Konstruktoren und Methoden testet. Zahlreiche
   weitergehende Tests sind vorlaeufig noch auskommentiert ("deaktiviert").

3. Entkommentarisieren ("aktivieren") Sie im Testprogramm die Zeilen

   40 //    ts1.addTest(new MeineSammlungJut("testSize01"));
   41 //    ts1.addTest(new MeineSammlungJut("testSize02"));

   Dadurch werden die Testmethoden testSize01 und testSize02 aktiviert.
   Diese Testmethoden testen (wie ihre Namen andeuten) die Methode size.
   Wenn Sie die Datei MeineSammlungJut.java jetzt compilieren und
   wieder ausfuehren lassen, wird ein roter Balken erscheinen.

4. Verbessern Sie in dieser Datei (MeineSammlung.java) den Rumpf
   der Methode size durch einen besseren Rumpf und lassen Sie
   das Testprogramm erneut ausfuehren. Wiederholen Sie diesen Schritt
   solange bis das Testprogramm einen gruenen Balken zeigt.

Wiederholen Sie die Schritte 3. und 4. fuer die folgenden Zeilen
in der Testdatei MeineSammlungJut.java:

   40 //    ts1.addTest(new MeineSammlungJut("testSize01"));
   41 //    ts1.addTest(new MeineSammlungJut("testSize02"));
   42
   43 //    ts1.addTest(new MeineSammlungJut("testIsEmpty01"));
   44 //    ts1.addTest(new MeineSammlungJut("testIsEmpty02"));
   45
   46 //    ts1.addTest(new MeineSammlungJut("testToString01"));
   47 //    ts1.addTest(new MeineSammlungJut("testToString02"));
   48 //    ts1.addTest(new MeineSammlungJut("testToString03"));
   49
   50 //    ts1.addTest(new MeineSammlungJut("testContains01"));
   51 //    ts1.addTest(new MeineSammlungJut("testContains02"));
   52 //    ts1.addTest(new MeineSammlungJut("testContains03"));
   53
   54 //    ts1.addTest(new MeineSammlungJut("testIterator01"));
   55 //    ts1.addTest(new MeineSammlungJut("testIterator02"));
   56 //    ts1.addTest(new MeineSammlungJut("testIterator03"));
   57
   58 //    ts1.addTest(new MeineSammlungJut("testContainsAll01"));
   59 //    ts1.addTest(new MeineSammlungJut("testContainsAll02"));
   60 //    ts1.addTest(new MeineSammlungJut("testContainsAll03"));
   61
   62 //    ts1.addTest(new MeineSammlungJut("testEquals01"));
   63 //    ts1.addTest(new MeineSammlungJut("testEquals02"));
   64 //    ts1.addTest(new MeineSammlungJut("testEquals03"));
   65
   66 //    ts1.addTest(new MeineSammlungJut("testToArray01"));
   67 //    ts1.addTest(new MeineSammlungJut("testToArray02"));
   68 //    ts1.addTest(new MeineSammlungJut("testToArray03"));

Empfehlung:
Da die Methoden dieser Klasse zum Teil voneinander abhaengen, sollten
sie in einer bestimmten Reihenfolge implementiert und getestet werden.
Besonders empfehlenswert ist die folgende Reihenfolge:
size, isEmpty, toString, contains, die Klasse Iterator (mit ihren Methoden
hasNext und next), containsAll, equals, toArray (ohne Param) und toArray
(mit Param).

Sie haben diese Aufgabe fertig geloest, wenn in der Testdatei
MeineSammlungJut.java (in der Methode suite) alle Tests aktiviert sind
und das Testprogramm trotzdem einen gruenen Balken zeigt. Viel Erfolg!
------------------------------------------------------------------------ */
import java.util.Collection;
import java.util.Iterator;
import java.util.Arrays;
import java.util.NoSuchElementException;

class MeineSammlung<K> implements Collection<K> {
   final boolean TEST = false;
   // ---------------------------------------------------------------------
   private K[] mr; // Meine Reihung, der "Kern" eines MeineSammlung-Objekts
   // ---------------------------------------------------------------------
   // Drei Konstruktoren:
   @SuppressWarnings("unchecked")
   public MeineSammlung(K[] mr) {
      this.mr = (K[]) new Object[mr.length];
      System.arraycopy(mr, 0, this.mr, 0, mr.length);
      if (TEST) pln("TST: mr.getClass(): " + mr.getClass().getName());
   } // Konstruktor MeineSammlung

   @SuppressWarnings("unchecked")
   public MeineSammlung() {
      this((K[]) new Object[0]);
   } // Standardkonstruktor MeineSammlung

   @SuppressWarnings("unchecked")
   public MeineSammlung(Collection<? extends K> c) {
      mr = (K[]) new Object[c.size()];
      c.toArray(mr);
      if (TEST) pln("TST: mr.getClass(): " + mr.getClass().getName());
   } // Konstruktor MeineSammlung
   // ---------------------------------------------------------------------
   // Eine triviale Hilfsmethode:
   private boolean wirfUOE() {throw new UnsupportedOperationException();}
      // Trick: Die Methode wirfUOE wurde als Funktion programmiert, damit
      // man sie z.B. nach return aufrufen darf. Diese "Funktion" liefert
      // aber nie ein Ergebnis, sondern wirft immer nur eine Ausnahme.
   // ---------------------------------------------------------------------
   // Alle optionalen Methoden der Schnittstelle Collection sind hier
   // schon fertig implementiert (allerdings nur "trivial"):

   public boolean add      (K      kob )               {return wirfUOE();}
   public boolean remove   (Object   ob)               {return wirfUOE();}
   public boolean addAll   (Collection<? extends K> c) {return wirfUOE();}
   public boolean removeAll(Collection<?>           c) {return wirfUOE();}
   public boolean retainAll(Collection<?>           c) {return wirfUOE();}
   public void    clear    ()                          {       wirfUOE();}

   // Auch die nicht-optionale Methode hashCode ist hier schon
   // fertig implementiert:
   public int hashCode() {
      // Diese Hash-Funktion ist der aus der Klasse AbstractList
      // "nachempfunden":
      int hashCode = 1, summand;
      for (int i=0; i< mr.length; i++) {
         summand  = (mr[i]==null ? 0 : mr[i].hashCode());
         hashCode = 31*hashCode + summand;
      }
      if (TEST) pln("TST: hashCode: " + hashCode);
      return hashCode;
   } // hashCode

   // Ende der bereits fertig implementierten Vereinbarungen
   // =====================================================================
   // Jetzt kommen die Vereinbarungen, die noch "ergaenzt" werden muessen:

   String meld = "Eine noch nicht implementierte Methode wurde aufgerufen: ";

   public int size() {
      pln(meld + "size");         // MUSS ENTFERNT UND
      return -999;                // ERSETZT WERDEN (1)
   }

   public boolean isEmpty() {
      pln(meld + "isEmpty");      // MUSS ENTFERNT UND
      return true;                // ERSETZT WERDEN (2)
   }

   public String toString() {
      // Liefert eine String-Repraesentation dieser Sammlung (ganz
      // entsprechend wie die toString-Methode der Klasse ArrayList).
      // Beispiele:
      //
      // Typ der Sammlung       Moegliches Ergebnis von toString:
      // MeineSammlung<String>  "[Hallo, Sonja!, Wie geht's?]"
      // MeineSammlung<String>  "[ABC, null, DEF, null, null]"
      // MeineSammlung<String>  "[]"
      // MeineSammlung<Integer> "[17, -25, 34]"
      // MeineSammlung<Integer> "[17, -25, null, 34, null]"
      // MeineSammlung<Integer> "[]"

      pln(meld + "toString");     // MUSS ENTFERNT UND
      return null;                // ERSETZT WERDEN (3)
   } // toString

   public boolean contains(Object ob) {
      pln(meld + "contains");     // MUSS ENTFERNT UND
      return true;                // ERSETZT WERDEN (4)
   } // contains

   // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   // Zu jedem Objekt einer Klasse MeineSammlung<K> gehoert
   // eine innere Klasse namens MeinIterator. Die Methoden hasNext und
   // next muessen noch ergaenzt werden, die Methode remove ist schon
   // (trivial) implementiert.
   private class MeinIterator implements Iterator<K> {
      int    indOfNext = 0;       // Index DER Komponenten, die von next
                                  // als naechste geliefert wird.
      public boolean hasNext() {
         pln(meld + "hasNext");   // MUSS ENTFERNT UND
         return true;             // ERSETZT WERDEN (5)
      }

      public K       next   () {
         pln(meld + "next");      // MUSS ENTFERNT UND
         return null;             // ERSETZT WERDEN (6)
      }

      public void    remove () {wirfUOE();}
   } // class MeinIterator

   public Iterator<K> iterator() {
      pln(meld + "iterator");     // MUSS ENTFERNT UND
      return null;                // ERSETZT WERDEN (7)
   } // iterator
   // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   public boolean containsAll(Collection<?> c) {
      pln(meld + "containsAll");  // MUSS ENTFERNT UND
      return true;                // ERSETZT WERDEN (8)
   }

   public boolean equals(Object ob) {
      // Liefert true, wenn ob identisch ist mit dieser Sammlung, oder
      // wenn die folgenden drei Bedingungen erfuellt sind:
      // 1. Das Objekt ob ist eine Sammlung der Klasse MeineSammlung.
      // 2. Jede Komponente, die (ein oder mehrmals) in ob
      //    enthalten ist, ist auch in dieser Sammlung (this) enthalten.
      // 3. Jede Komponente, die (ein oder mehrmals) in dieser Sammlung
      //    (this) enthalten ist, ist auch in ob enthalten.

      pln(meld + "toArray");      // MUSS ENTFERNT UND
      return false;               // ERSETZT WERDEN (9)
   } // equals

   public Object[] toArray() {
      pln(meld + "toArray");      // MUSS ENTFERNT UND
      return null;                // ERSETZT WERDEN (10)
   } // toArray

   public <T>  T[] toArray(T[] rei)  {
      pln(meld + "toArray");      // MUSS ENTFERNT UND
      return null;                // ERSETZT WERDEN (11)
   } // toArray
   // =====================================================================
   // Die main-Methode kann um Befehle ergaenzt werden, die bestimmte
   // Methoden "ein bisschen testen".
   static public void main(String[] _) {
      pln("--------------------------------------------------");
      pln("Zum Testen der generischen Klasse MeineSammlung<K>");
      pln("eignet sich das Programm MeineSammlungJut.java!   ");
      pln("--------------------------------------------------");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class MeineSammlung
