// Datei MeineSammlungJut.java
/* ------------------------------------------------------------------------
JUnit-Klasse zum Testen der Klasse MeineSammlung.
------------------------------------------------------------------------ */
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.util.NoSuchElementException;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class MeineSammlungJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {

      // In der Klasse MeineSammlungJut werden alle parameterlosen
      // Prozeduren ("void-Methoden"), deren Namen mit "test" beginnen,
      // zu einer Test-Suite namens ts1 zusammengefasst:
      // TestSuite ts1 = new TestSuite(MeineSammlungJut.class);

      // Alternativ zu obigem Vorgehen kann man die parameterlosen
      // Test-Prozeduren auch einzeln in ein TestSuite-Objekt einfuegen
      // etwa so:
      TestSuite ts1 = new TestSuite("MeineSammlungJut");

      ts1.addTest(new MeineSammlungJut("testKonstruktor01"));
      ts1.addTest(new MeineSammlungJut("testKonstruktor02"));
      ts1.addTest(new MeineSammlungJut("testKonstruktor03"));
      ts1.addTest(new MeineSammlungJut("testKonstruktor04"));

      ts1.addTest(new MeineSammlungJut("testAdd01"));
      ts1.addTest(new MeineSammlungJut("testRemove01"));
      ts1.addTest(new MeineSammlungJut("testAddAll01"));
      ts1.addTest(new MeineSammlungJut("testRemoveAll01"));
      ts1.addTest(new MeineSammlungJut("testRetainAll01"));

//    ts1.addTest(new MeineSammlungJut("testSize01"));
//    ts1.addTest(new MeineSammlungJut("testSize02"));

//    ts1.addTest(new MeineSammlungJut("testIsEmpty01"));
//    ts1.addTest(new MeineSammlungJut("testIsEmpty02"));

//    ts1.addTest(new MeineSammlungJut("testToString01"));
//    ts1.addTest(new MeineSammlungJut("testToString02"));
//    ts1.addTest(new MeineSammlungJut("testToString03"));

//    ts1.addTest(new MeineSammlungJut("testContains01"));
//    ts1.addTest(new MeineSammlungJut("testContains02"));
//    ts1.addTest(new MeineSammlungJut("testContains03"));

//    ts1.addTest(new MeineSammlungJut("testIterator01"));
//    ts1.addTest(new MeineSammlungJut("testIterator02"));
//    ts1.addTest(new MeineSammlungJut("testIterator03"));

//    ts1.addTest(new MeineSammlungJut("testContainsAll01"));
//    ts1.addTest(new MeineSammlungJut("testContainsAll02"));
//    ts1.addTest(new MeineSammlungJut("testContainsAll03"));

//    ts1.addTest(new MeineSammlungJut("testEquals01"));
//    ts1.addTest(new MeineSammlungJut("testEquals02"));
//    ts1.addTest(new MeineSammlungJut("testEquals03"));

//    ts1.addTest(new MeineSammlungJut("testToArray01"));
//    ts1.addTest(new MeineSammlungJut("testToArray02"));
//    ts1.addTest(new MeineSammlungJut("testToArray03"));

      return ts1;
   } // suite
   // ---------------------------------------------------------------------
   public MeineSammlungJut(String name) {super(name);}
   // ---------------------------------------------------------------------
   // Ein paar gloabale Strings, die in zahlreiche Sammlungen eingefuegt
   // werden:
   final String a = "ABC";
   final String b = "HIJKL";
   final String c = "CD";
   final String d = "EFG";
   final String e = "MNO";
   final String f = "BCDE";
   final String x = "XXX";
   // ---------------------------------------------------------------------
   // Zuerst werden die (in Aufgabe 4) vorgegebenen Konstruktoren und
   // Methoden getestet.
   // ---------------------------------------------------------------------
   public void testKonstruktor01() {
      // Gibt es einen Konstruktor mit einem Reihungsparameter?
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      assertNotNull("Konstruktor mit Reihungsparam hat versagt!", ms);
   } // testKonstruktor01
   // ---------------------------------------------------------------------
   public void testKonstruktor02() {
      // Gibt es einen Konstruktor mit einem Collection-Param.?
      String[]              sr = {a, b, c};
      Collection   <String> cr = Arrays.asList(sr);
      MeineSammlung<String> ms = new MeineSammlung<String>(cr);
      assertNotNull("Konstruktor mit Collection-Param hat versagt!", ms);
   } // testKonstruktor02
   // ---------------------------------------------------------------------
   public void testKonstruktor03() {
      // Gibt es einen Standard-Konstruktor?
      MeineSammlung<Number>  ms = new MeineSammlung<Number>();
      assertNotNull("Standardkonstruktor hat versagt!", ms);
   } // testKonstruktor03
   // ---------------------------------------------------------------------
   public void testKonstruktor04() {
      // Hat der Konstrukor mit dem Collection-Param einen Param.
      // des Typs Collection<? extends K> (und nicht nur einen Param.
      // des Typs Collection<K>) ?
      Integer[]              ir = {17, 35, 28};
      Collection   <Integer> ic = Arrays.asList(ir);
      MeineSammlung<Number>  ms = new MeineSammlung<Number>(ic);
      assertNotNull("Konstruktor mit Collection-Param hat versagt!", ms);
   } // testKonstruktor04
   // ---------------------------------------------------------------------
   public void testAdd01() {
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      try {
         ms.add(d);
         fail("UnsupportedOperationException wurde erwartet!");
      } catch (UnsupportedOperationException ex) {}
   } // testAdd01
   // ---------------------------------------------------------------------
   public void testRemove01() {
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      try {
         ms.remove(c);
         fail("UnsupportedOperationException wurde erwartet!");
      } catch (UnsupportedOperationException ex) {}
   } // testRemove01
   // ---------------------------------------------------------------------
   public void testAddAll01() {
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      ArrayList    <String> as = new ArrayList    <String>();
      try {
         ms.addAll(as);
         fail("UnsupportedOperationException wurde erwartet!");
      } catch (UnsupportedOperationException ex) {}
   } // testAddAll01
   // ---------------------------------------------------------------------
   public void testRemoveAll01() {
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      ArrayList    <String> as = new ArrayList    <String>();
      try {
         ms.removeAll(as);
         fail("UnsupportedOperationException wurde erwartet!");
      } catch (UnsupportedOperationException ex) {}
   } // testRemove01
   // ---------------------------------------------------------------------
   public void testRetainAll01() {
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      ArrayList    <String> as = new ArrayList    <String>();
      try {
         ms.retainAll(as);
         fail("UnsupportedOperationException wurde erwartet!");
      } catch (UnsupportedOperationException ex) {}
   } // testRetainAll01
   // ---------------------------------------------------------------------
   // Dann werden die (in Aufagabe 5) zu programmierenden Methoden
   // getestet.
   // ---------------------------------------------------------------------
   public void testSize01() {
      // Initialisiert der Konstruktor mit dem Reihungsparameter
      // die Sammlung mit der richtigen Laenge (size)?
      String[]               sr = {a, b, c};
      MeineSammlung<String>  ms = new MeineSammlung<String>(sr);
      assertEquals("size liefert nicht 3!", 3, ms.size());

      Integer[]              ir = new Integer[0];
      MeineSammlung<Integer> mi = new MeineSammlung<Integer>(ir);
      assertEquals("size liefert nicht 0!", 0, mi.size());
   } // testSize01
   // ---------------------------------------------------------------------
   public void testSize02() {
      // Initialisiert der Konstruktor mit dem Sammlungsparameter
      // die Sammlung mit der richtigen Laenge (size)?
      String[]               sr = {a, b, c};
      Collection   <String>  sc = Arrays.asList(sr);
      MeineSammlung<String>  ms = new MeineSammlung<String>(sc);
      assertEquals("size liefert nicht 3!", 3, ms.size());

      Integer[]              ir = new Integer[0];
      Collection<Integer>    ic = Arrays.asList(ir);
      MeineSammlung<Integer> mi = new MeineSammlung<Integer>(ic);
      assertEquals("size liefert nicht 0!", 0, mi.size());
   } // testSize02
   // ---------------------------------------------------------------------
   public void testIsEmpty01() {
      // Initialisiert der Konstruktor mit dem Reihungsparameter
      // die Sammlung mit der richtigen Laenge (size)?
      String[]               sr = {a, b, c};
      MeineSammlung<String>  ms = new MeineSammlung<String>(sr);
      assertFalse("isEmpty liefert nicht false!", ms.isEmpty());

      Integer[]              ir = new Integer[0];
      MeineSammlung<Integer> mi = new MeineSammlung<Integer>(ir);
      assertTrue("isEmpty liefert nicht true!", mi.isEmpty());
   } // testIsEmpty01
   // ---------------------------------------------------------------------
   public void testIsEmpty02() {
      // Initialisiert der Konstruktor mit dem Sammlungsparameter
      // die Sammlung mit der richtigen Laenge (size)?
      String[]               sr = {a, b, c};
      Collection   <String>  sc = Arrays.asList(sr);
      MeineSammlung<String>  ms = new MeineSammlung<String>(sc);
      assertFalse("isEmpty liefert nicht false!", ms.isEmpty());

      Integer[]              ir = new Integer[0];
      Collection<Integer>    ic = Arrays.asList(ir);
      MeineSammlung<Integer> mi = new MeineSammlung<Integer>(ic);
      assertTrue("isEmpty liefert nicht true!", mi.isEmpty());
   } // testSize02
   // ---------------------------------------------------------------------
   public void testToString01() {
      // Funktioniert toString bei einer nicht-leeren Sammlung?
      // (die Reihenfolge der Komponenten wird ausdruecklich nicht
      // geprueft)

      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      String                st = ms.toString();
      assertTrue ("toString: [ fehlt!",     st.startsWith("["));
      assertTrue ("toString: ] fehlt!",     st.endsWith  ("]"));
      assertTrue ("toString: "+a+" fehlt!", st.contains  (a));
      assertTrue ("toString: "+b+" fehlt!", st.contains  (b));
      assertTrue ("toString: "+c+" fehlt!", st.contains  (c));
      assertFalse("toString: "+x+" sollte fehlen!", st.contains(x));
   } // testToString01
   // ---------------------------------------------------------------------
   public void testToString02() {
      // Funktioniert toString bei einer nicht-leeren Sammlung?
      // (die Reihenfolge der Komponenten wird ausdruecklich nicht
      // geprueft)

      Number[]              ir = {123, 4.5, -67};
      MeineSammlung<Number> ms = new MeineSammlung<Number>(ir);
      String                st = ms.toString();
      assertTrue ("toString: [ fehlt!",   st.startsWith("["));
      assertTrue ("toString: ] fehlt!",   st.endsWith  ("]"));
      assertTrue ("toString: 123 fehlt!", st.contains("123"));
      assertTrue ("toString: 4.5 fehlt!", st.contains("4.5"));
      assertTrue ("toString: -67 fehlt!", st.contains("-67"));
      assertFalse("toString: 321 sollte fehlen!", st.contains("321"));
   } // testToString02
   // ---------------------------------------------------------------------
   public void testToString03() {
      // Funktioniert toString bei einer leeren Sammlung?

      Number[]              ir = {};
      MeineSammlung<Number> ms = new MeineSammlung<Number>(ir);
      String                st = ms.toString().trim();
      assertEquals("toString: Fehler bei leerer Sammlung!", "[]", st);
   } // testToString03
   // ---------------------------------------------------------------------
   public void testContains01() {
      // Funktioniert contains bei einer nicht-leeren Sammlung?
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      assertTrue ("contains(a) liefert nicht true!",  ms.contains(a));
      assertTrue ("contains(b) liefert nicht true!",  ms.contains(b));
      assertTrue ("contains(c) liefert nicht true!",  ms.contains(c));
      assertFalse("contains(x) liefert nicht false!", ms.contains(x));
   } // testContains01
   // ---------------------------------------------------------------------
   public void testContains02() {
      // Funktioniert contains bei einer leeren Sammlung?
      Integer[]              ir  = new Integer[0];
      MeineSammlung<Integer> mi  = new MeineSammlung<Integer>(ir);
      String                 mld = "contains liefert true bei leerem this!";
      assertFalse ("A " + mld, mi.contains(a));
      assertFalse ("B " + mld, mi.contains(new Integer(0)));
   } // testContains02
   // ---------------------------------------------------------------------
   public void testContains03() {
      // Funktioniert contains bei einer Sammlung, die null-Kompos
      // enthaelt und bei der man nach null-Kompos sucht?
      Integer[]              ir  = {null, 10, null, 20, null};
      MeineSammlung<Integer> mi  = new MeineSammlung<Integer>(ir);
      String                 mld = "contains scheitert an null in mr!";
      assertTrue  ("A " + mld, mi.contains(10));
      assertTrue  ("B " + mld, mi.contains(20));
      assertTrue  ("C " + mld, mi.contains(null));
      assertFalse ("D " + mld, mi.contains(30));
   } // testContains02
   // ---------------------------------------------------------------------
   public void testIterator01() {
      // Liefert die Methode iterator wirklich ein Objekt (und nicht
      // nur null)?
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      Iterator<String>      it = ms.iterator();

      assertNotNull("iterator hat null  geliefert", it);
   } // testIterator01
   // ---------------------------------------------------------------------
   public void testIterator02() {
      // Funktionieren die Methoden next und hasNext in einem von der
      // Methode iterator (einer nicht-leeren Sammlung) gelieferten Objekt
      // auch richtig?

      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      Iterator<String>      it = ms.iterator();
      assertTrue  ("it.hasNext hat false geliefert", it.hasNext());
      assertEquals("it hat falsche Komp. geliefert", a, it.next());
      assertTrue  ("it.hasNext hat false geliefert", it.hasNext());
      assertEquals("it hat falsche Komp. geliefert", b, it.next());
      assertTrue  ("it.hasNext hat false geliefert", it.hasNext());
      assertEquals("it hat falsche Komp. geliefert", c, it.next());
      assertFalse ("it.hasNext hat true  geliefert", it.hasNext());

      try {
         Object ob = it.next();
         fail("next hat keine Ausnahme geworfen");
      } catch (NoSuchElementException ex) {
         // Alles o.k., next hat die richtige Art von Ausnahme geworfen
      } catch (ArrayIndexOutOfBoundsException ex) {
         fail("next hat falsche Ausnahme geworfen!");
      }
   } // testIterator02
   // ---------------------------------------------------------------------
   public void testIterator03() {
      // Funktionieren die Methoden next und hasNext in einem von der
      // Methode iterator (einer leeren Sammlung) gelieferten Objekt
      // auch richtig?

      String[]              sr = {};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);
      Iterator<String>      it = ms.iterator();
      assertFalse  ("it.hasNext hat true geliefert", it.hasNext());

      try {
         Object ob = it.next();
         fail("next hat keine Ausnahme geworfen");
      } catch (NoSuchElementException ex) {
         // Alles o.k., next hat die richtige Art von Ausnahme geworfen
      } catch (ArrayIndexOutOfBoundsException ex) {
         fail("next hat falsche Ausnahme geworfen!");
      }
   } // testIterator03
   // ---------------------------------------------------------------------
   public void testContainsAll01() {
      // Funktioniert containsAll bei einer nicht-leeren Sammlung?
      Number[] nr1 = {123, 3.5, 34, 4.5F};
      Number[] nr2 = {3.5, 123, 34, 4.5F};
      Number[] nr3 = {123, 3.5, 34, 5.5F};
      Number[] nr4 = {};

      MeineSammlung<Number> an1 = new MeineSammlung<Number>(Arrays.asList(nr1));
      MeineSammlung<Number> an2 = new MeineSammlung<Number>(Arrays.asList(nr2));
      MeineSammlung<Number> an3 = new MeineSammlung<Number>(Arrays.asList(nr3));
      MeineSammlung<Number> an4 = new MeineSammlung<Number>(Arrays.asList(nr4));

      assertTrue ("an1 enthaelt nicht an1!", an1.containsAll(an1));
      assertTrue ("an1 enthaelt nicht an2!", an1.containsAll(an2));
      assertFalse("an1 enthaelt an3!",       an1.containsAll(an3));
      assertTrue ("an1 enthaelt nicht an4!", an1.containsAll(an4));
   } // testContainsAll01
   // ---------------------------------------------------------------------
   public void testContainsAll02() {
      // Funktioniert containsAll bei einer leeren Sammlung?
      Number[] nr1 = {};
      Number[] nr2 = {3.5, 123, 34, 4.5F};
      Number[] nr3 = {};

      MeineSammlung<Number> an1 = new MeineSammlung<Number>(Arrays.asList(nr1));
      MeineSammlung<Number> an2 = new MeineSammlung<Number>(Arrays.asList(nr2));
      MeineSammlung<Number> an3 = new MeineSammlung<Number>(Arrays.asList(nr3));

      assertTrue ("an1 enthaelt nicht an1!", an1.containsAll(an1));
      assertFalse("an1 enthaelt an2!",       an1.containsAll(an2));
      assertTrue ("an1 enthaelt nicht an3!", an1.containsAll(an3));
   } // testContainsAll02
   // ---------------------------------------------------------------------
   public void testContainsAll03() {
      // Funktioniert containsAll bei einer Sammlung, die
      // null-Kompos enthaelt und in der man nach null-Kompos sucht?
      Number[] nr1 = {10,   null, 20, null};
      Number[] nr2 = {null,   20, 10, null};
      Number[] nr3 = {null, null, 10, 30};
      Number[] nr4 = {};

      MeineSammlung<Number> an1 = new MeineSammlung<Number>(Arrays.asList(nr1));
      MeineSammlung<Number> an2 = new MeineSammlung<Number>(Arrays.asList(nr2));
      MeineSammlung<Number> an3 = new MeineSammlung<Number>(Arrays.asList(nr3));
      MeineSammlung<Number> an4 = new MeineSammlung<Number>(Arrays.asList(nr4));

      assertTrue ("an1 enthaelt nicht an1!", an1.containsAll(an1));
      assertTrue ("an1 enthaelt nicht an2!", an1.containsAll(an2));
      assertFalse("an1 enthaelt an3!",       an1.containsAll(an3));
      assertTrue ("an1 enthaelt nicht an4!", an1.containsAll(an4));
   } // testContainsAll03
   // ---------------------------------------------------------------------
   public void testEquals01() {
      // Liefert equals in den richtigen Faellen false?
      String[]              ra = {a, b, c};
      MeineSammlung<String> ma = new MeineSammlung<String>(ra);
      Number[]              rb = {123, 4.5, -67};
      String[]              rc = {a, b, x};

      // Verschiedene Objekte, NICHT GLEICH ma sind:
      String                str = "Hallo";
      Collection  <Integer> cil = new ArrayList    <Integer>(); // l wie leer
      Collection   <Number> cnb = new ArrayList     <Number>(Arrays.asList(rb));
      Collection   <String> csa = new ArrayList     <String>(Arrays.asList(ra));
      MeineSammlung<Number> mnb = new MeineSammlung <Number>(Arrays.asList(rb));
      MeineSammlung<Object> mob = new MeineSammlung <Object>(Arrays.asList(rb));
      MeineSammlung<String> msc = new MeineSammlung <String>(Arrays.asList(rc));

      assertFalse("ma ist gleich str!", ma.equals(str));
      assertFalse("ma ist gleich cil!", ma.equals(cil));
      assertFalse("ma ist gleich cnb!", ma.equals(cnb));
      assertFalse("ma ist gleich csa!", ma.equals(csa));
      assertFalse("ma ist gleich mnb!", ma.equals(mnb));
      assertFalse("ma ist gleich mob!", ma.equals(mob));
      assertFalse("ma ist gleich msc!", ma.equals(msc));

      // Warum sind die einzelnen Sammlungen ungleich ma?
      // str, cil, cnb, csa, mnb haben falschen Typ
      // mob: Typ o.k., Laengen gleich, aber unterschiedliche Inhalte
      // msc: Typ o.k., Laengen gleich, aber unterschiedliche Inhalte
   } // testEquals01
   // ---------------------------------------------------------------------
   public void testEquals02() {
      // Liefert equals in den richtigen Faellen true?

      String[]              sr1 = {a, a, b, c};
      String[]              sr2 = {c, c, b, a};
      String[]              sr3 = {c, c, b, a, c};

      Number[]              nr1 = {123, 4.5, 4.5, -67, 4.5};
      Number[]              nr2 = {123, 4.5, -67, 4.5};
      Number[]              nr3 = {123, 4.5, -67, 4.5};

      // Sammlungen, die GLEICH ms1 sein sollten:
      MeineSammlung<String> ms1 = new MeineSammlung<String>(Arrays.asList(sr1));
      MeineSammlung<String> ms2 = new MeineSammlung<String>(Arrays.asList(sr2));
      MeineSammlung<Object> ms3 = new MeineSammlung<Object>(Arrays.asList(sr3));

      // Sammlungen, die GLEICH mr1 sein sollten:
      MeineSammlung<Number> mr1 = new MeineSammlung<Number>(Arrays.asList(nr1));
      MeineSammlung<Number> mr2 = new MeineSammlung<Number>(Arrays.asList(nr2));
      MeineSammlung<Object> mr3 = new MeineSammlung<Object>(Arrays.asList(nr3));

      assertTrue("ms1 ist ungleich ms1!", ms1.equals(ms1));
      assertTrue("ms1 ist ungleich ms2!", ms1.equals(ms2));
      assertTrue("ms1 ist ungleich ms3!", ms1.equals(ms3));

      assertTrue("mr1 ist ungleich mr1!", mr1.equals(mr1));
      assertTrue("mr1 ist ungleich mr2!", mr1.equals(mr2));
      assertTrue("mr1 ist ungleich mr3!", mr1.equals(mr3));

      // Ist equals kommutativ? D.h. gilt nicht nur
      // mx.equals(my) sondern auch my.equals(mx)?
      assertTrue("ms1 ist ungleich ms1!", ms1.equals(ms1));
      assertTrue("ms2 ist ungleich ms1!", ms2.equals(ms1));
      assertTrue("ms3 ist ungleich ms1!", ms3.equals(ms1));

      assertTrue("mr1 ist ungleich mr1!", mr1.equals(mr1));
      assertTrue("mr2 ist ungleich mr1!", mr2.equals(mr1));
      assertTrue("mr3 ist ungleich mr1!", mr3.equals(mr1));

   } // testEquals02
   // ---------------------------------------------------------------------
   public void testEquals03() {
      // Liefert die equals-Methode false wenn ihr Param gleich null ist?
      String[]              sr = {a, b, c};
      MeineSammlung<String> ms = new MeineSammlung<String>(sr);

      try {
         assertFalse(ms.equals(null));
      } catch (Exception ex) {
         fail("ms.equals(null) hat eine Ausnahme geworfen statt false " +
              "zu liefern:\n" + ex);
      }
   } // testEquals03
   // ---------------------------------------------------------------------
   public void testToArray01() {
      // Liefert die parameterlose toArray-Methode eine Reihung vom Typ
      // Object[] und mit dem richtigen Inhalt?

      String[]               sr = {a, b, c};
      Collection   <String>  sc = Arrays.asList(sr);
      MeineSammlung<String>  ms = new MeineSammlung<String>(sc);

      Object                 ergO = ms.toArray();

      assertEquals("Ergebnis von toArray ist nicht vom Typ Object[]!",
         Object[].class, ergO.getClass());

      Object[]               ergR = (Object[]) ergO;

      assertTrue("Ergebnis von toArray hat falschen Inhalt!",
         Arrays.equals(sr, ergR));

   } // testToArray01
   // ---------------------------------------------------------------------
   public void testToArray02() {
      // Liefert die parameterlose toArray-Methode eine leere Reihung vom
      // Typ Object[] wenn die aktuelle Sammlung leer ist?

      String[]               sr = {};
      Collection   <String>  sc = Arrays.asList(sr);
      MeineSammlung<String>  ms = new MeineSammlung<String>(sc);

      Object                 ergO = ms.toArray();

      assertEquals("Ergebnis von toArray ist nicht vom Typ Object[]!",
         Object[].class, ergO.getClass());

      Object[]               ergR = (Object[]) ergO;

      assertEquals("Ergebnis von toArray ist keine leere Reihung!",
         0, ergR.length);

   } // testToArray02
   // ---------------------------------------------------------------------
   public void testToArray03() {
      // Liefert die toArray-Methode mit dem Reihungsparameter als
      // Ergebnis eines Reihung des richtigen Typs? Ist die Ergebnis-
      // reihung identisch mit dem Parameter (ohne bzw. mit einem null-
      // Wert darin) bzw. eine neue Reihung der richtigen Laenge?

      // Drei Reihungen von unterschiedlichen Typen, aber alle
      // mit Permutationen gleicher Komponenten (4 Objekte und ein null) :
      Double[]              rd  = {2.5, 1.5, 4.5, null, 3.5};
      Number[]              rn  = {1.5, 4.5, null, 2.5, 3.5};
      Object[]              ro  = {null, 3.5, 2.5, 1.5, 4.5};

      // Drei MeineSammlung-Objekte von unterschiedlichen Typen, aber alle
      // mit gleichen Inhalten:
      MeineSammlung<Double> md  = new MeineSammlung<Double>(Arrays.asList(rd));
      MeineSammlung<Number> mn  = new MeineSammlung<Number>(Arrays.asList(rn));
      MeineSammlung<Object> mo  = new MeineSammlung<Object>(Arrays.asList(ro));

      // Reihungen, die als Parameter von toArray benutzt werden sollen:
      Double[]              pd0 = new Double[0]; // Zu kurz
      Double[]              pd1 = new Double[5]; // Passt genau
      Double[]              pd2 = new Double[6]; // Laenger als noetig

      Number[]              pn0 = new Number[0]; // Zu kurz
      Number[]              pn1 = new Number[5]; // Passt genau
      Number[]              pn2 = new Number[8]; // Laenger als noetig

      Object[]              po0 = new Object[0]; // Zu kurz
      Object[]              po1 = new Object[5]; // Passt genau
      Object[]              po2 = new Object[7]; // Laenger als noetig

      // Jetzt wird die Methode toArray 9 Mal aufgerufen:
      Object                ed0 = md.toArray(pd0);
      Object                ed1 = md.toArray(pd1);
      Object                ed2 = md.toArray(pd2);

      Object                en0 = md.toArray(pn0);
      Object                en1 = md.toArray(pn1);
      Object                en2 = md.toArray(pn2);

      Object                eo0 = md.toArray(po0);
      Object                eo1 = md.toArray(po1);
      Object                eo2 = md.toArray(po2);

      // Sind die 9 Ergebnisse von toArray Reihungen des richtigen Typs?
      assertEquals("A Typfehler in toArray!", pd0.getClass(), ed0.getClass());
      assertEquals("B Typfehler in toArray!", pd1.getClass(), ed1.getClass());
      assertEquals("C Typfehler in toArray!", pd2.getClass(), ed2.getClass());

      assertEquals("D Typfehler in toArray!", pn0.getClass(), en0.getClass());
      assertEquals("E Typfehler in toArray!", pn1.getClass(), en1.getClass());
      assertEquals("F Typfehler in toArray!", pn2.getClass(), en2.getClass());

      assertEquals("G Typfehler in toArray!", po0.getClass(), eo0.getClass());
      assertEquals("H Typfehler in toArray!", po1.getClass(), eo1.getClass());
      assertEquals("I Typfehler in toArray!", po2.getClass(), eo2.getClass());

      // Die Object-Ergebnisse von toArray in Reihungen casten:
      Double[]              rd0  = (Double[]) ed0;
      Double[]              rd1  = (Double[]) ed1;
      Double[]              rd2  = (Double[]) ed2;

      Number[]              rn0  = (Number[]) en0;
      Number[]              rn1  = (Number[]) en1;
      Number[]              rn2  = (Number[]) en2;

      Object[]              ro0  = (Object[]) eo0;
      Object[]              ro1  = (Object[]) eo1;
      Object[]              ro2  = (Object[]) eo2;

      // Anfangsstuecke der zu langen Reihungen erzeugen:
      Double[]              rd3  = Arrays.copyOf(rd2, rd.length);
      Number[]              rn3  = Arrays.copyOf(rn2, rn.length);
      Object[]              ro3  = Arrays.copyOf(ro2, ro.length);

      // Steht in jeder "zu langen" Ergebnisreihung an der richtigen Stelle
      // ein abschliessender null-Werte?
      assertNull("A Kein null in rd2[3]!", rd2[5]);
      assertNull("B Kein null in rn2[3]!", rn2[5]);
      assertNull("C Kein null in ro2[3]!", ro2[5]);

      // Steht in den "viel zu langen" Ergebnisreihungen nur EIN null und
      // dahinter noch der alte Inhalt?
      assertSame("A Original-Reihungsinhalt zerstoert!", pn2[6], rn2[6]);
      assertSame("B Original-Reihungsinhalt zerstoert!", pn2[7], rn2[7]);
      assertSame("C Original-Reihungsinhalt zerstoert!", po2[6], ro2[6]);

      // Die Methode toArray mit Parameter muss ihren Parameter als
      // Ergebnis liefern, wenn der lang genug ist. Sonst muss sie eine
      // neue Reihung liefern. Hat sie das immer richtig getan?
      assertNotSame("A toArray hat neue Reihung erzeugt!", pd0, ed0);
      assertSame   ("B toArray hat neue Reihung erzeugt!", pd1, ed1);
      assertSame   ("C toArray hat neue Reihung erzeugt!", pd2, ed2);

      assertNotSame("D toArray hat neue Reihung erzeugt!", pn0, en0);
      assertSame   ("C toArray hat neue Reihung erzeugt!", pn1, en1);
      assertSame   ("E toArray hat neue Reihung erzeugt!", pn2, en2);

      assertNotSame("F toArray hat neue Reihung erzeugt!", po0, eo0);
      assertSame   ("G toArray hat neue Reihung erzeugt!", po1, eo1);
      assertSame   ("H toArray hat neue Reihung erzeugt!", po2, eo2);

      // Haben die von toArray gelieferten Reihungen den richtigen Inhalt?
      assertTrue("A Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, rd0));
      assertTrue("B Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, rd1));
      assertTrue("C Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, rd3));

      assertTrue("D Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, rn0));
      assertTrue("C Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, rn1));
      assertTrue("E Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, rn3));

      assertTrue("F Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, ro0));
      assertTrue("G Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, ro1));
      assertTrue("H Ergebnisreihung hat falschen Inhalt!", Arrays.equals(rd, ro3));

   } // testToArray03
   // ---------------------------------------------------------------------
   static public void main(String[] _) {

      /*
      // Entweder so:
      pln("--------------------------------------------------");
      pln("Die Tests in dieser JUnit-Klasse koennen Sie durch");
      pln("folgendes Kommando ausfuehren lassen:             ");
      pln("> java junit.awtui.TestRunner MeineSammlungJut  ");
      pln("--------------------------------------------------");
      */

      // Oder so:
      pln("MeineSammlungJut: Jetzt geht es los!");
      junit.awtui.TestRunner.run(MeineSammlungJut.class);
      pln("MeineSammlungJut: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class MeineSammlungJut
