//Datei HashSetJut05.java
/* ------------------------------------------------------------------------
JUnit-Klasse zum Testen der Klasse HashSet (unvollstaendig!).

Getestet wird die toString-Methode in Objekten des Typs HashSet<String>.
Problem: Bei Sammlungen eines HashSet-Typs (z.B. HashSet<String>) darf
das Ergebnis der toString-Methode die Komponenten der Sammlung in einer
beliebigen Reihenfolge enthalten. Weil die toString-Methode nicht nur
EIN bestimmtes Ergebnis, sondern EINES VON VIELEN verschiedenen Ergebnissen
liefern darf, ist es schwierig, diese Methode zu testen.
------------------------------------------------------------------------ */
package paket01;

// Benoetigt wird JUnit 3.8 (nicht JUnit 4.0 oder spaetere!):
import junit.framework.TestCase;
import junit.framework.Test;
import junit.framework.TestSuite;

import java.util.HashSet;
import java.util.Arrays;
import java.util.List;
import java.util.ArrayList;

public class HashSetJut05 extends TestCase {
   // ---------------------------------------------------------------------
   // Ein Konstruktor ist notwendig, um die Testfaelle einzeln zu einer
   // TestSuite hinzufuegen zu koennen:
   public HashSetJut05(String s) { super(s); }
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Die Testfaelle in dieser Datei werden hier (etwas umstaendlich)
      // einzeln zu der TestSuite ts hinzugefuegt, damit man sie einzeln
      // auskommentieren/einkommentieren kann.

      TestSuite ts = new TestSuite();

      ts.addTest(new HashSetJut05("testToString01"));
      ts.addTest(new HashSetJut05("testToString02"));
//    ts.addTest(new HashSetJut05("testToString03"));
//    ts.addTest(new HashSetJut05("testToString04"));
//    ts.addTest(new HashSetJut05("testToString05"));
//    ts.addTest(new HashSetJut05("testToString06"));
//    ts.addTest(new HashSetJut05("testToString07"));

      return ts;

      // Der folgende Befehl liefert eine TestSuite, die alle Methoden
      // enthaelt, deren Namen mit "test" beginnen:
//    return new TestSuite(HashSetJut05.class);
   } // suite
   // ---------------------------------------------------------------------
   // Jetzt kommen die Testfaelle:
   // ---------------------------------------------------------------------
   public void testToString01() { // Sammlung der Groesse 0
      HashSet<String> hs   = new HashSet<String>();
      String          ist  = hs.toString();
      String          soll = "[]";
      assertEquals(soll, ist);
   } // testToString01
   // ---------------------------------------------------------------------
   public void testToString02() { // Groesse 1
      HashSet<String> hs   = new HashSet<String>();
      hs.add("Hallo Sonja!");
      String          ist  = hs.toString();
      String          soll = "[Hallo Sonja!]";
      assertEquals(soll, ist);
   } // testToString02
   // ---------------------------------------------------------------------
   public void testToString03() { // Groesse 3
      doTheTesting(new String[]{"ABC", "BCDE", "CD"});
   } // testToString03
   // ---------------------------------------------------------------------
   public void testToString04() { // Groesse 20
      doTheTesting(new String[]{
         "01", "02", "03", "04", "05", "06", "07", "08", "09", "10",
         "11", "12", "13", "14", "15", "16", "17", "18", "19", "20"
      });
   } // testToString04
   // ---------------------------------------------------------------------
   public void testToString05() { // Mit "sich ueberlappenden" Komponenten
      doTheTesting(new String[]{
         "A", "AA", "AAAA", "AAAAA", "AAAAAA", "AAAAAAA"
      });
   } // testToString05
   // ---------------------------------------------------------------------
   public void testToString06() { // Mit Trennern als Komponenten
      doTheTesting(new String[]{
         "A", "]", "AA", "[", "AAA", ", , , ", "AAAA", "][", ", "
      });
   } // testToString06
   // ---------------------------------------------------------------------
   public void testToString07() { // Mit "boesen Trennern" als Komponenten
      doTheTesting(new String[]{
         "+", ", ", ", , ", "*", "."
      });
   } // testToString07
   // ---------------------------------------------------------------------
   // Die meisten Testfaelle rufen nur die folgende Methode mit einem
   // geeigneten Parameter auf
   // ---------------------------------------------------------------------
   public void doTheTesting(String[] sr) {
      // Aus sr wird eine Sammlung hs des Typs HashSet<String> gemacht.
      // Das Ergebnis von hs.toString() wird getestet.

      // Sollen zusaetzliche Testausgaben ausgegeben werden?
      final boolean TST = false;

      if (TST) pln("doTheTesting, sr: " + Arrays.toString(sr));
      fail(); // MUSS ERSETZT WERDEN

   } // doTheTesting
   // ---------------------------------------------------------------------
   static public void main(String[] _) {

      // Falls unter Eclipse dieses Programm mit "Run As Java Application"
      // ausgefuehrt wird (statt mit "Run As JUnit Test"):
      junit.awtui.TestRunner.run(HashSetJut05.class);

      // Von einer Kommandozeile aus kann dieses Programm
      // auch mit folgendem Kommando gestartet werden:
      // > java junit.awtui.TestRunner HashSetJut05

      pln("HashSetJut05: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class HashSetJut05

