// Datei XmlJStdTst01.java
/* ------------------------------------------------------------------------
Dieses Programm testet einen Teil des Moduls XmlJStd:
Mehrere XML-Dateien werden eingelesen und in  DOM-Document-Objekte
umgewandelt. Die Objekte werden lesbar ("als Einrueckbaeume") zur
Standardausgabe ausgegeben.
------------------------------------------------------------------------ */
import org.w3c.dom.Document; // Nicht org.jdom.Document    !

class XmlJStdTst01 {
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("XmlJStdTst01: Jetzt geht es los!%n");

      // Die Pfadnamen der einzulesenden Dateien:
      String[] pfade = {
         "daten01A.xml",
         "daten01E.xml",
         "daten02B.xml",
         "daten02E.xml",
      };

      // Alle Dateien in pfade werden mit einem nicht-validierenden
      // Parser eingelesen:
      for (String pfad : pfade) {
         printf("=================================================%n");
         printf("Die Datei %s: %n%n", pfad);
         Document doc = XmlJStd.lies(pfad);
         if (doc != null) XmlJStd.gibLesbarAus(doc);
      }

      // Jetzt wird eine Datei mit einem (gegen eine DTD) validierenden
      // Parser eingelesen:
      String pfad = "daten02G.xml";
      printf("=================================================%n");
      printf("Die Datei %s: %n%n", pfad);
      Document doc = XmlJStd.liesVD(pfad);
      if (doc != null) XmlJStd.gibLesbarAus(doc);

      printf("------------------------------------------%n");
      printf("XmlJStdTst01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class XmlJStdTst01
/* ------------------------------------------------------------------------
Die Ausgabe des Programms XmlJStdTst01.java (2007-09-14):

XmlJStdTst01: Jetzt geht es los!
=================================================
Die Datei daten01A.xml: 

XML-Version: 1.0
Encodierung: UTF-8
Standalone : false

Element: <name>Exception in thread "main" java.util.UnknownFormatConversionException: Conversion = 'k'
	at java.util.Formatter$FormatSpecifier.conversion(Unknown Source)
	at java.util.Formatter$FormatSpecifier.<init>(Unknown Source)
	at java.util.Formatter.parse(Unknown Source)
	at java.util.Formatter.format(Unknown Source)
	at java.io.PrintStream.format(Unknown Source)
	at java.io.PrintStream.printf(Unknown Source)
	at XmlJStd.printf(XmlJStd.java:415)
	at XmlJStd.gibLesbarAusR(XmlJStd.java:352)
	at XmlJStd.gibLesbarAus(XmlJStd.java:324)
	at XmlJStdTst01.main(XmlJStdTst01.java:29)
------------------------------------------------------------------------ */
