// Datei XmlJStdTst03.java
/* ------------------------------------------------------------------------
Dieses Programm testet einen Teil des Moduls XmlJStd:
Mehrere XML-Dateien werden auf Gueltigkeit (engl. validity) geprueft
Die Pruefergebnisse werden ausgegeben.
------------------------------------------------------------------------ */
import org.w3c.dom.Document; // Nicht org.jdom.Document    !

class XmlJStdTst03 {
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("XmlJStdTst03: Jetzt geht es los!%n");

      // Die Pfadnamen der einzulesenden Dateien und der Kopien:
      String[] pfade = {
         "daten01A.xml", "dJStd01A.xml",
         "daten01E.xml", "dJStd01E.xml",
         "daten02B.xml", "dJStd02B.xml",
         "daten02E.xml", "dJStd02E.xml",
      };

      for (int i=0; i<pfade.length/2; i++) {
         String pfadOrig = pfade[2*i];
         String pfadKopi = pfade[2*i + 1];
         printf("****************************************************%n");
         printf("Inhalt der Originaldatei %s:  %n", pfadOrig);
         printf("----------------------------------------------------%n");
         XmlJStd.gibTextDateiAus(pfadOrig);
         printf("----------------------------------------------------%n");
         Document doc = XmlJStd.lies(pfadOrig);
         if (doc == null) continue;
         XmlJStd.schreib(doc, pfadKopi);
         printf("Inhalt der Kopie %s:  %n", pfadKopi);
         printf("----------------------------------------------------%n");
         XmlJStd.gibTextDateiAus(pfadKopi);
      }

      printf("****************************************************%n");
      printf("XmlJStdTst03: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class XmlJStdTst03
/* ------------------------------------------------------------------------
Die Ausgabe des Programms XmlJStdTst03.java (2007-09-14):

XmlJStdTst03: Jetzt geht es los!
****************************************************
Inhalt der Originaldatei daten01A.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8"?>
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten01A.xml: 
   Wohlgeformt und gueltig (valid) nach nameA.dtd und nameA.xsd.
   Enthaelt keinen Hinweis auf nameA.dtd oder nameA.xsd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->     


<name>

  <vor_name> Alan  </vor_name>
  <nach_name>Turing</nach_name>
</name>
----------------------------------------------------
Inhalt der Kopie dJStd01A.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8"?>
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten01A.xml: 
   Wohlgeformt und gueltig (valid) nach nameA.dtd und nameA.xsd.
   Enthaelt keinen Hinweis auf nameA.dtd oder nameA.xsd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->
<name>
    <vor_name> Alan  </vor_name>
    <nach_name>Turing</nach_name>
</name>
****************************************************
Inhalt der Originaldatei daten01E.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8"?>
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten01E.xml "E" wir "error": 
   Wohlgeformt aber nicht gueltig (valid) (weder nach nameA.dtd
   noch nach nameA.xsd).
   Enthaelt keinen Hinweis auf nameA.dtd oder nameA.xsd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->     

<name>
  <vor_name> Alan    </vor_name>
  <vor_name> Mathison</vor_name> <!-- 2. Vorname ungueltig! -->
  <nach_name>Turing  </nach_name>
</name>

----------------------------------------------------
Inhalt der Kopie dJStd01E.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8"?>
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten01E.xml "E" wir "error": 
   Wohlgeformt aber nicht gueltig (valid) (weder nach nameA.dtd
   noch nach nameA.xsd).
   Enthaelt keinen Hinweis auf nameA.dtd oder nameA.xsd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->
<name>
    <vor_name> Alan    </vor_name>
    <vor_name> Mathison</vor_name>
    <!-- 2. Vorname ungueltig! -->
    <nach_name>Turing  </nach_name>
</name>
****************************************************
Inhalt der Originaldatei daten02B.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten02B.xml: 
   Wohlgeformt und gueltig (valid) nach personA.dtd und 
   personA.xsd.
   Enthaelt einen Hinweis auf personA.dtd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->     
<!DOCTYPE person SYSTEM "personA.dtd">

<person>

  <name>
    <vor_name>Alan</vor_name>
    <nach_name>Turing</nach_name>
  </name>
  Normaler 
  Text Nr 1
  <!--Kommentar zwischen 2 Texten-->
  Normaler Text Nr 2
  <beruf>Informatiker</beruf>
  <![CDATA[<beruf>Dozent</beruf>]]>
  <beruf>Mathematiker</beruf>
  Entity Ref.: &amp;lt; steht fuer &lt;
  <beruf land="England" zeit="WK2">Kryptograf</beruf>
  <?SuperEditor Zeilenwechsel ignorieren!?>
  &hi;

</person>
----------------------------------------------------
Inhalt der Kopie dJStd02B.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE person SYSTEM "personA.dtd">
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten02B.xml: 
   Wohlgeformt und gueltig (valid) nach personA.dtd und 
   personA.xsd.
   Enthaelt einen Hinweis auf personA.dtd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->
<person>
    <name>
        <vor_name>Alan</vor_name>
        <nach_name>Turing</nach_name>
    </name>
  Normaler 
  Text Nr 1

    <!--Kommentar zwischen 2 Texten-->
  Normaler Text Nr 2
  <beruf>Informatiker</beruf><![CDATA[<beruf>Dozent</beruf>]]><beruf>Mathematiker</beruf>
  Entity Ref.: &amp;lt; steht fuer &lt;<beruf
        land="England" zeit="WK2">Kryptograf</beruf><?SuperEditor Zeilenwechsel ignorieren!?>&hi;</person>
****************************************************
Inhalt der Originaldatei daten02E.xml:  
----------------------------------------------------
<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   Datei daten02E.xml: ("E" wie "error")
   Wohlgeformt aber nicht gueltig (valid) (weder nach 
   personA.dtd noch nach personA.xsd).
   Enthaelt keinen Hinweis auf personA.dtd
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  -->     


<person>
  <name>
    <vor_name> Alan    </vor_name>
    <vor_name> Mathison</vor_name> <!-- 2. Vorname ungueltig! -->
    <nach_name>Turing  </nach_name>
  </name>
  Normaler 
  Text Nr 1
  <!--Kommentar zwischen 2 Texten-->
  Normaler Text Nr 2
  <beruf>Informatiker</beruf>
  <![CDATA[<beruf>Dozent</beruf>]]>
  <beruf>Mathematiker</beruf>
  Entity Ref.: &amp;lt; steht fuer &lt;
  <beruf land="England" zeit="WK2">Kryptograf</beruf>
  <?SuperEditor Zeilenwechsel ignorieren!?>
  &hi;
</person>
----------------------------------------------------
[Fatal Error] daten02E.xml:26:7: The entity "hi" was referenced, but not declared.
In XmlJStd.lies: org.w3c.dom.ls.LSException
Message: The entity "hi" was referenced, but not declared.
****************************************************
XmlJStdTst03: Das war's erstmal!
------------------------------------------------------------------------ */
