// Datei XmlJdomTst01.java
/* ------------------------------------------------------------------------
Dieses Programm testet einen Teil des Moduls XmlJdom:
Mehrere XML-Dateien werden eingelesen und in JDOM-Document-Objekte
umgewandelt. Die Objekte werden lesbar ("als Einrueckbaeume") zur
Standardausgabe ausgegeben.
------------------------------------------------------------------------ */
import org.jdom.Document;    // Nicht org.w3c.dom.Document !

class XmlJdomTst01 {
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("XmlJdomTst01: Jetzt geht es los!%n");

      // Die Pfadnamen der einzulesenden Dateien:
      String[] pfade = {
         "daten01A.xml",
         "daten01E.xml",
         "daten02B.xml",
         "daten02E.xml",
      };

      for (String pfad : pfade) {
         printf("------------------------------------------%n");
         printf("Die Datei %s: %n%n", pfad);
         Document doc = XmlJdom.lies(pfad);
         if (doc != null) XmlJdom.gibLesbarAus(doc);
      }

      printf("------------------------------------------%n");
      printf("XmlJdomTst01: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class XmlJdomTst01
/* ------------------------------------------------------------------------
Die Ausgabe des Programms XmlJdomTst01.java (2007-09-14):

XmlJdomTst01: Jetzt geht es los!
------------------------------------------
Die Datei daten01A.xml: 

Element: <name>
   Element: <vor_name>
      Text: "Alan"
   Element: <nach_name>
      Text: "Turing"
------------------------------------------
Die Datei daten01E.xml: 

Element: <name>
   Element: <vor_name>
      Text: "Alan"
   Element: <vor_name>
      Text: "Mathison"
   Comment: " 2. Vorname ungueltig! "
   Element: <nach_name>
      Text: "Turing"
------------------------------------------
Die Datei daten02B.xml: 

Element: <person>
   Element: <name>
      Element: <vor_name>
         Text: "Alan"
      Element: <nach_name>
         Text: "Turing"
   Text: "Normaler Text Nr 1"
   Comment: "Kommentar zwischen 2 Texten"
   Text: "Normaler Text Nr 2"
   Element: <beruf>
      Text: "Informatiker"
   CDATASection: "<beruf>Dozent</beruf>"
   Element: <beruf>
      Text: "Mathematiker"
   Text: "Entity Ref.: &lt; steht fuer <"
   Element: <beruf>
      Text: "Kryptograf"
   ProcessingInstruction:
      Fuer Programm: SuperEditor
      Instruktion:   Zeilenwechsel ignorieren!
   Text: "Hi Alan, how are you?"
------------------------------------------
Die Datei daten02E.xml: 

In XmlJdom.lies: org.jdom.input.JDOMParseException
Message: Error on line 26 of document file:/d:/meineDateien/BspJava/XML/daten02E.xml: The entity "hi" was referenced, but not declared.
------------------------------------------
XmlJdomTst01: Das war's erstmal!
------------------------------------------------------------------------ */
