// Datei XmlJdomTst02.java
/* ------------------------------------------------------------------------
Dieses Programm testet einen Teil des Moduls XmlJdom:
Mehrere XML-Dateien werden auf Gueltigkeit (engl. validity) geprueft
Die Pruefergebnisse werden ausgegeben.
------------------------------------------------------------------------ */
import org.jdom.Document;    // Nicht org.w3c.dom.Document !

class XmlJdomTst02 {
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      printf("XmlJdomTst02: Jetzt geht es los!%n");

      final char DAZ = '"'; // Ein doppeltes Anfuehrungszeichen

      // Die Pfadnamen der einzulesenden Dateien:
      String[] pfade = {
         "daten01A.xml",   "nameA.xsd",
         "daten01E.xml",   "nameA.xsd",
         "daten02B.xml", "personA.xsd",
         "daten02E.xml", "personB.xsd",
      };

      for (int i=0; i<pfade.length/2; i++) {
         String pfadXml = pfade[2*i];
         String pfadXsd = pfade[2*i + 1];
         printf("------------------------------------------%n");
         printf("Geprueft wird die XML-Datei %s: %n",   pfadXml);
         printf("gegen die  XML-Schema-Datei %s: %n%n", pfadXsd);
         Document jdomDoc = XmlJdom.lies(pfadXml);
         if (jdomDoc != null) {
            boolean erg = XmlJdom.istGueltigVS(jdomDoc, pfadXsd);
            printf("Ergebnis: Die XML-Datei ist %sGUELTIG!%n",
               erg ? "" : "NICHT ");
         } else {
            printf("Aus der Datei %s konnte kein JDOM-Objekt erzeugt " +
                   "werden!%n", pfadXml);
         }
      } // for i

      printf("------------------------------------------%n");
      printf("XmlJdomTst02: Das war's erstmal!%n");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class XmlJdomTst02
/* ------------------------------------------------------------------------
Die Ausgabe des Programms XmlJdomTst02.java (2007-09-14):

XmlJdomTst02: Jetzt geht es los!
------------------------------------------
Geprueft wird die XML-Datei daten01A.xml:
gegen die  XML-Schema-Datei nameA.xsd:

Ergebnis: Die XML-Datei ist GUELTIG!
------------------------------------------
Geprueft wird die XML-Datei daten01E.xml:
gegen die  XML-Schema-Datei nameA.xsd:

In XmlJdom.istGueltigVS: org.xml.sax.SAXParseException
Message: cvc-complex-type.2.4.a: Invalid content was found starting with element 'vor_name'. One of '{nach_name}' is expected.
Ergebnis: Die XML-Datei ist NICHT GUELTIG!
------------------------------------------
Geprueft wird die XML-Datei daten02B.xml:
gegen die  XML-Schema-Datei personA.xsd:

Ergebnis: Die XML-Datei ist GUELTIG!
------------------------------------------
Geprueft wird die XML-Datei daten02E.xml:
gegen die  XML-Schema-Datei personA.xsd:

In XmlJdom.lies: org.jdom.input.JDOMParseException
Message: Error on line 26 of document file:/d:/meineDateien/BspJava/XML/daten02E.xml: The entity "hi" was referenced, but not declared.
------------------------------------------
XmlJdomTst02: Das war's erstmal!
------------------------------------------------------------------------ */
